SUBROUTINE calc_deltat

  !-----------------------------------------------------------------------
  ! Role : calcule le pas de temps qui est stocke dans la variable deltat
  !-----------------------------------------------------------------------

  USE functions
  USE param
  USE inter
  USE files

  implicit none

  ! Declaration des variables locales
  !----------------------------------
  INTEGER :: k,l,i,j
  REAL :: delt,mmax,val

  ! Debut
  !-------

  !PRINT*,'Entree dans calcule_deltat'

  ! Calcul du pas de temps
  !-------------------------------

!!$  mmax=0.0
!!$  DO k=1,mz
!!$     DO j=1,my
!!$        DO i=1,mx
!!$           val=(max(0.0,Vx(i-1,j,k))/dxp(i-1)-min(0.0,Vx(i,j,k))/dxp(i)&
!!$                &+max(0.0,Vy(i,j-1,k))/dyp(j-1)-min(0.0,Vy(i,j,k))/dyp(j)&
!!$                &+max(0.0,Vz(i,j,k-1))/dzp(k-1)-min(0.0,Vz(i,j,k))/dzp(k))&
!!$                &/C%porosite(i,j,k)
!!$           if (val>mmax) mmax=val
!!$        end DO
!!$     end DO
!!$  end DO
!!$  deltat=cfl/mmax

  ! Ajustement du pas de temps si T+deltat est superieur au temps de stockage
  ! de la solution ou au temps de lecture du terme source
  !--------------------------------------------------------------------------

     IF (tester_temps<=nbr_stock) THEN
        IF (T+deltat>=tps_stock(tester_temps)) THEN
           deltat=tps_stock(tester_temps)-T
           pri=1
        END IF
     END IF

  IF ((T+deltat>T_max).AND.(steady_state/=1)) deltat=T_max-T

500 FORMAT(E19.7)
600 FORMAT(E13.7)

  !PRINT*,'Sortie de calcule_deltat'

  ! Fin
  !-----

END SUBROUTINE calc_deltat
