SUBROUTINE domaine

  USE functions
  USE files
  USE mes_types
  USE param
  USE alloc
  !USE inter

  implicit none

  type m1
     real :: xmin,xmax
     integer :: nbr_mesh
  end type m1
  integer :: nbr_int,nbr_points,nbr_save,tester,counter
  real :: xmin,xmax,nbr_mesh,val
  type (m1),dimension(:),pointer :: maille1

  CHARACTER(len=len_buffer) :: buffer
  INTEGER :: i,j,k,l
  real :: diffusion_loc1,diffusion_loc2,diffusion_loc3,absc,ord,scal
  REAL,DIMENSION(:,:),POINTER :: ppp

  PRINT*,'Enregistrement des parametres relatifs aux milieu stratifie'

  open (unit=udom,file=FDOM,status='old')

  ! Maillage
  !----------

  ! Direction x
!-------------

buffer=lireligne(udom)
READ(buffer, *, err = 10) nbr_int

allocate (maille1(1:nbr_int))
mx=0
do i=1,nbr_int
   buffer=lireligne(udom)
   READ(buffer, *, err = 10) maille1(i)%xmin,maille1(i)%xmax,&
        &maille1(i)%nbr_mesh
   mx=mx+maille1(i)%nbr_mesh
end do
call alloue_real_1D (deltax,1,mx,1)
call alloue_real_1D (dxp,0,mx,1)
call alloue_real_1D (xinterp,0,mx,1)
nbr_save=0
do i=1,nbr_int
   val=(maille1(i)%xmax-maille1(i)%xmin)/maille1(i)%nbr_mesh 
   do j=1,maille1(i)%nbr_mesh
      deltax(nbr_save+j)=val
   end do
   nbr_save=nbr_save+maille1(i)%nbr_mesh
end do
dxp(0)=deltax(1)
do i=1,mx-1
   dxp(i)=.5*(deltax(i)+deltax(i+1))
end do
dxp(mx)=deltax(mx)
xinterp(0)=.5
do i=1,mx-1
   xinterp(i)=.5*deltax(i)/dxp(i)
end do
xinterp(mx)=.5
deallocate (maille1)


! Direction y
!------------
buffer=lireligne(udom)
READ(buffer, *, err = 10) nbr_int

allocate (maille1(1:nbr_int))
my=0
do i=1,nbr_int
   buffer=lireligne(udom)
   READ(buffer, *, err = 10) maille1(i)%xmin,maille1(i)%xmax,&
        &maille1(i)%nbr_mesh
   my=my+maille1(i)%nbr_mesh
end do
call alloue_real_1D (deltay,1,my,1)
call alloue_real_1D (dyp,0,my,1)
call alloue_real_1D (yinterp,0,my,1)
nbr_save=0
do i=1,nbr_int
   val=(maille1(i)%xmax-maille1(i)%xmin)/maille1(i)%nbr_mesh 
   do j=1,maille1(i)%nbr_mesh
      deltay(nbr_save+j)=val
   end do
   nbr_save=nbr_save+maille1(i)%nbr_mesh
end do
dyp(0)=deltay(1)
do j=1,my-1
   dyp(j)=.5*(deltay(j)+deltay(j+1))
end do
dyp(my)=deltay(my)

yinterp(0)=.5
do j=1,my-1
   yinterp(j)=.5*deltay(j)/dyp(j)
end do
yinterp(my)=.5
deallocate (maille1)

! Enregistrement des noeuds du maillage
!---------------------------------------

allocate (xpoints(mx))
allocate (xmesh(0:mx))
allocate (ypoints(my))
allocate (ymesh(0:my))

xmesh(0)=xd_min
xmesh(1)=xd_min+deltax(1)
xpoints(1)=xd_min+.5*deltax(1)
do i=2,mx
   xmesh(i)=xmesh(i-1)+deltax(i)
   xpoints(i)=xpoints(i-1)+.5*(deltax(i-1)+deltax(i))
end do

ymesh(0)=yd_min
ymesh(1)=yd_min+deltay(1)
ypoints(1)=yd_min+.5*deltay(1)
do j=2,my
   ymesh(j)=ymesh(j-1)+deltay(j)
   ypoints(j)=ypoints(j-1)+.5*(deltay(j-1)+deltay(j))
end do

mtotal=mx*my
nx=mx+1
ny=my+1
! Break
!------
buffer=lireligne(udom)
READ(buffer, *, err = 10) xbreak,ybreak
DO i=1,mx
   if ((xmesh(i-1)<=xbreak).and.(xmesh(i)>xbreak)) ib=i
END DO
DO j=1,my
   if ((ymesh(j-1)<=ybreak).and.(ymesh(j)>ybreak)) jb=j
END DO

! Allocations
!-------------
call alloue

! Mesh plot
!----------

counter=0
DO i=1,mx
   if ((xpoints(i)>=xp_min).and.(xpoints(i)<=xp_max)) counter=counter+1
END DO
allocate(xp_points(counter))
allocate(xp_mesh(0:counter))
mpx=counter
npx=mpx+1

counter=0
DO i=1,mx
   if ((xpoints(i)>=xp_min).and.(xpoints(i)<=xp_max)) then
      counter=counter+1
      xp_points(counter)=xpoints(i)
      xp_mesh(counter-1)=xmesh(i-1)
      xp_mesh(counter)=xmesh(i)
   END if
END DO

counter=0
DO j=1,my
   if ((ypoints(j)>=yp_min).and.(ypoints(j)<=yp_max)) counter=counter+1
END DO
allocate(yp_points(counter))
allocate(yp_mesh(0:counter))
mpy=counter
npy=mpy+1

counter=0
DO j=1,my
   if ((ypoints(j)>=yp_min).and.(ypoints(j)<=yp_max)) then
      counter=counter+1
      yp_points(counter)=ypoints(j)
      yp_mesh(counter-1)=ymesh(j-1)
      yp_mesh(counter)=ymesh(j)
   END if
END DO

mptotal=mpx*mpy

! multi-domain
!-------------

buffer=lireligne(udom)
READ(buffer, *, err = 10) nbr_strates

DO i=1,nbr_strates

   buffer=lireligne(udom)
   READ(buffer, *, err = 10) nbr_points
   
   !PRINT*,'nbr=',nbr_points
   CALL alloue_real_2D(ppp,1,nbr_points+1,1,2,1)
   
   DO j=1,nbr_points
      buffer=lireligne(udom)
      READ(buffer, *, err = 10) ppp(j,1),ppp(j,2)
      
   END DO
   ppp(nbr_points+1,:)=ppp(1,:)
   
   buffer=lireligne(udom)
   READ(buffer, *, err = 10) diffusion_loc1,diffusion_loc2,diffusion_loc3
   DO k=1,my
      DO j=1,mx
         absc=xpoints(j)
         ord=ypoints(k)
         scal=1.0
         tester=1
         DO l=1,nbr_points
            scal=(ppp(l,2)-ppp(l+1,2))*(absc-ppp(l,1))+(ppp(l+1,1)-ppp(l,1))&
                 & *(ord-ppp(l,2))
            IF(scal<0.0) tester=0
         END DO
         
         IF(tester==1) THEN
            C%diffusion(j,k,1)=diffusion_loc1
            C%diffusion(j,k,2)=diffusion_loc2
            C%diffusion(j,k,3)=diffusion_loc3
         END IF
      END DO
   END DO
   CALL alloue_real_2D(ppp,1,nbr_points+1,1,2,0)
END DO
   
C%diffusion(0,:,:)=C%diffusion(1,:,:)
C%diffusion(mx+1,:,:)=C%diffusion(mx,:,:)
C%diffusion(:,0,:)=C%diffusion(:,1,:)
C%diffusion(:,my+1,:)=C%diffusion(:,my,:)
C%diffusion(0,0,:)=C%diffusion(1,1,:)
C%diffusion(mx+1,my+1,:)=C%diffusion(mx,my,:)
C%diffusion(0,my+1,:)=C%diffusion(1,my,:)
C%diffusion(mx+1,0,:)=C%diffusion(mx,1,:)


!!$print*,'d11=',C%diffusion(:,:,1)
!!$print*,'d22=',C%diffusion(:,:,2)
!!$print*,'d12=',C%diffusion(:,:,3)
!!$stop

  PRINT*,'OK'
  PRINT*,' '
  RETURN

10 PRINT*,'Erreur dans les donnees du milieu stratifie'
  CALL desallocation
  STOP

END SUBROUTINE domaine








