MODULE files

  !--------------------------------------------------------------------------
  ! Role : module contenant les noms et les unites de lecture des fichiers
  !  d'entree/sortie
  !--------------------------------------------------------------------------

  INTEGER,PARAMETER :: uadvance=10,uparam=11,udom=12,ucsub=13,uclpr=14
  INTEGER,PARAMETER :: uplotplt=15,ucisub=16,utool=17,uplot_m=18,upuit=19
  INTEGER,PARAMETER :: uvalpuit=20,uplotsci=21,usave=22

  CHARACTER(len=40),SAVE :: FADVANCE,FPARAM,FDOM,FCLSUB,FCLPR,FPLOTPLT,FCSUB
  CHARACTER(len=40),SAVE :: FTOOL,FPLOT_M,FPUIT,FVALPUIT,FPLOTSCI,FSAVE

  !---------------
  ! Correspondance
  !---------------

  ! FADVANCE, uadvance  : fichier et unite de lecture des parametres avances
  ! FPARAM, uparam      : fichier et unite de lecture des parametres principaux
  ! FDOM, udom     : fichier et unite de lecture des parametres du milieu
  !                       dans le cas d'un milieu stratifie
  ! FCSUB, ucsub      : fichier et unite de lecture des conditions aux
  !                       limites et initiale pour les substrats
  ! FCLPR, uclpr        : fichier et unite de lecture des conditions aux
  !                       limites pour la pression si la vitesse est de Darcy
  ! FPLOTPLT, uplotvtk  : fichier et unite du fichier d'impression vtk
  ! FPLTSCI,uplotsci    : fichier et unite du fichier d'impression scilab
  ! FPLOT_M, uplot      : fichier et unite du fichier d'impression gnuplot pour   !                       la masse de compose en fonction du temps
  ! FCLPR, uclpr        : fichier et unite de lecture de cl pression
  ! FTOOL, utool        : fichier et unite outil
  ! FPUIT, upuit        : fichier et unite de lecture des donnees concernant
  !                       le terme source de type puit
  ! FVALPUIT,uvalpuit   : fichier et unite de lecture des valeurs des termes
  !                       sources s'ils sont de type puit
  ! FSAVE, usave        : fichier et unite de lecture du fichier de securite 
  !                       pour les reprises

END MODULE files
