SUBROUTINE lec_param

  !-------------------------------------------------------------------------
  ! Role : lecture des parametres relatifs au domaine, aux schemas utilises
  !  et aux substrats
  !-------------------------------------------------------------------------

  USE param
  USE alloc
  USE mes_types
  USE functions
  USE files

  IMPLICIT NONE

  INTEGER :: i,j
  CHARACTER(len=len_buffer) :: buffer
  REAL :: vit1,vit2,per_circ

  INTEGER :: nbr_iter_movie
  REAL :: t_movie_min,t_movie_max,dt_movie

  PRINT*,'Lecture des parametres principaux'

  open (unit=uparam,file=FPARAM,status='old')

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xd_min,xd_max,yd_min,yd_max
  lx=xd_max-xd_min
  ly=yd_max-yd_min

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) t_0,t_max

  T=t_0
  iter=0
  tester_temps=1

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xp_min,xp_max,yp_min,yp_max

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) nbr_stock

  CALL alloue_real_1D(tps_stock,1,nbr_stock,1)
  
  DO i=1,nbr_stock
     READ(uparam,*) tps_stock(i)
     IF (tps_stock(i)<t_0) THEN
        PRINT*,'Erreur tps_stock < t_0',i
     ELSE IF (tps_stock(i)>t_max) THEN
        PRINT*,'Erreur tps_stock > t_max'
     END IF
  END DO

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) info

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) movie,t_movie_min,t_movie_max,nbr_iter_movie

  IF (movie==1) THEN
     FPLOT_MOVIE=FPLOTPLT
     deallocate (tps_stock)
     nbr_stock=nbr_iter_movie+1
     CALL alloue_real_1D(tps_stock,1,nbr_stock,1)
     dt_movie=(t_movie_max-t_movie_min)/nbr_iter_movie
     tps_stock(1)=0.0
     DO i=2,nbr_stock
        tps_stock(i)=(i-1)*dt_movie
     END DO
  END IF

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) steady_state,test_cv_stat

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) schema_transport

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) cfl

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) method_syslin_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) diff_precond

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) test_cv_diff

  !CALL alloue_vitesses

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) type_vit

  !PRINT*,'typ=',type_vit

  SELECT CASE (type_vit)
  CASE(1,3)
     buffer=lireligne(uparam)
     READ(buffer, *, err = 10) v1,v2
!!$  CASE (3)
!!$     buffer=lireligne(uparam)
!!$     READ(buffer, *, err = 10) per_circ
!!$     CALL calc_vit_circ(per_circ)
!!$     !PRINT*,'per_circ=',per_circ
  END SELECT

  !PRINT*,'Vitesse OK'

  
  buffer=lireligne(uparam)
  READ(buffer, *, err = 20) C%tau(1),C%tau(2)

  close(uparam)

  PRINT*,'OK'
  PRINT*,' '

  RETURN

10 PRINT*,"Erreur dans l'entree des parametres"
  close (uparam)
  STOP

20 PRINT*,'Erreur dans les parametres des substrats'
  close (uparam)
  STOP

END SUBROUTINE lec_param







