PROGRAM main

  !--------------------------------------------------------------------------
  ! PROGRAMME PRINCIPAL DE NEURO2D
  !--------------------------------------------------------------------------

  USE param
  USE mes_types
  USE files 
  USE inter
  USE plot

  integer :: m
  REAL :: mmax,val

  ! Lecture des fichiers
  !----------------------
  CALL lec_files

  ! Lecture des parametres
  !-----------------------
  CALL lec_param  

  ! Lecture du milieu
  !-------------------
  call domaine

  ! Fabrication du tableau de concatenation:
  ! Pour tout m, bij_tam(m,1)=i , bij_tam(m,2)=j 
  !----------------------------------------------
  
  DO m=1,mtotal
     bij_tab(m,1)=mod(m-1,mx)+1
     bij_tab(m,2)=mod((m-bij_tab(m,1))/mx,my)+1
  END DO

  ! Creation du fichier pour visit
  !--------------------------------
  CALL create_vtk

  ! Lecture des conditions initiales et aux limites
  !-------------------------------------------------
  call lec_csub (C%val)
  if (steady_state==1) steady_save=C%val

!!$
!!$  ! Prise en compte de l'option
!!$  !----------------------------
!!$  CALL make_option


  ! Calcul de la vitesse aux interfaces
  !-------------------------------------
  CALL calc_vitesse


  ! Calcul du pas de temps constant
  !--------------------------- -----
!!$  
  select case (schema_transport)
  case (1)
     mmax=0.0
     DO j=1,my
        DO i=1,mx
           val=(max(0.0,Vx(i-1,j))-min(0.0,Vx(i,j)))/deltax(i)&
                &+(max(0.0,Vy(i,j-1))-min(0.0,Vy(i,j)))/deltay(j)&
                &-(Vx(i,j)- Vx(i-1,j))/deltax(i)-(Vy(i,j)- Vy(i,j-1))/deltay(j)
           if (val>mmax) mmax=val
        end DO
     end DO

     deltat=cfl/mmax
     deltat_cst=deltat
     
  case (2)
     mmax=0.0
     DO j=1,my
        DO i=1,mx-1
           val=abs(Vx(i,j))/min(deltax(i),deltax(i+1))
           if (val>mmax) mmax=val
        end DO
     END DO

     DO j=1,my-1
        DO i=1,mx
           val=abs(Vy(i,j))/min(deltay(j),deltay(j+1))
           if (val>mmax) mmax=val
        end DO
     END DO
     deltat=1.0/mmax
     mmax=0.0
     DO j=1,my
        DO i=1,mx    
           val=(max(0.0,Vx(i-1,j))-min(0.0,Vx(i,j)))/deltax(i)&
                &+(max(0.0,Vy(i,j-1))-min(0.0,Vy(i,j)))/deltay(j)&
                &-(Vx(i,j)- Vx(i-1,j))/deltax(i)-(Vy(i,j)- Vy(i,j-1))/deltay(j)
           if (val>mmax) mmax=val
        end DO
     END DO
     
     deltat=min(deltat,cfl/mmax)
     deltat_cst=deltat
     
  end select

!!$deltat=0.01
!!$  deltat_cst=0.01

  ! Refractory period
  !------------------
  call init_refractory

  !Adimensionaing
  !--------------
  CALL adim

  ! Debut des iterations
  !---------------------
  CALL solver
!!$
!!$  ! Desallocation des tableaux
!!$  !---------------------------
!!$  CALL desallocation

  PRINT*,"End of execution"
  PRINT*,' '

END PROGRAM main
