SUBROUTINE calc_deltat

  !-----------------------------------------------------------------------
  ! Role : calcule le pas de temps qui est stocke dans la variable deltat
  !-----------------------------------------------------------------------

  USE functions
  USE param
  USE inter
  USE files

  implicit none

  ! Declaration des variables locales
  !----------------------------------
  INTEGER :: k,l,i,j
  REAL :: delt,mmax,val

  ! Debut
  !-------

  !PRINT*,'Entree dans calcule_deltat'

  ! Initialize deltat
  !------------------
  

  ! Calcul du pas de temps cfl
  !-------------------------------
!!$  select case (schema_transport)
!!$  case (1,2)
!!$     mmax=0.0
!!$     DO j=1,my
!!$        DO i=1,mx
!!$           val=(abs(Vx(i-1,j))+abs(Vx(i,j)))/deltax(i)&
!!$                &+(abs(Vy(i,j-1))+abs(Vy(i,j)))/deltay(j)
!!$           if (val>mmax) mmax=val
!!$        end DO
!!$  end DO
!!$  deltat=cfl/mmax
!!$end select
!!$
  select case (schema_transport)
  case (1)
     mmax=0.0
     DO j=1,my
        DO i=1,mx
           val=(max(0.0,Vx(i-1,j))-min(0.0,Vx(i,j)))/deltax(i)&
                &+(max(0.0,Vy(i,j-1))-min(0.0,Vy(i,j)))/deltay(j)&
                &-(Vx(i,j)- Vx(i-1,j))/deltax(i)-(Vy(i,j)- Vy(i,j-1))/deltay(j)
           if (val>mmax) mmax=val
        end DO
     end DO

     deltat=cfl/mmax
     deltat_cst=deltat
     
  case (2)
     mmax=0.0
     DO j=1,my
        DO i=1,mx-1
           val=abs(Vx(i,j))/min(deltax(i),deltax(i+1))
           if (val>mmax) mmax=val
        end DO
     END DO

     DO j=1,my-1
        DO i=1,mx
           val=abs(Vy(i,j))/min(deltay(j),deltay(j+1))
           if (val>mmax) mmax=val
        end DO
     END DO
     deltat=1.0/mmax
     mmax=0.0
     DO j=1,my
        DO i=1,mx    
           val=(max(0.0,Vx(i-1,j))-min(0.0,Vx(i,j)))/deltax(i)&
                &+(max(0.0,Vy(i,j-1))-min(0.0,Vy(i,j)))/deltay(j)&
                &-(Vx(i,j)- Vx(i-1,j))/deltax(i)-(Vy(i,j)- Vy(i,j-1))/deltay(j)
           if (val>mmax) mmax=val
        end DO
     END DO

     deltat=min(deltat,cfl/mmax)
  end select
  
  !deltat=0.0044

  ! Adjust deltat if greater than any refractory period
  !-----------------------------------------------------
  IF (C%tau(1)>zero) deltat=min(deltat,C%tau(1))
  IF (C%tau(2)>zero) deltat=min(deltat,C%tau(2))


  ! Ajustement du pas de temps si T+deltat est superieur au temps de stockage
  ! de la solution
  !--------------------------------------------------------------------------

     IF (tester_temps<=nbr_stock) THEN
        IF (T+deltat>=tps_stock(tester_temps)) THEN
           deltat=tps_stock(tester_temps)-T
           pri=1
        END IF
     END IF

  IF ((T+deltat>T_max).AND.(steady_state/=1)) deltat=T_max-T

500 FORMAT(E19.7)
600 FORMAT(E13.7)

  !PRINT*,'Sortie de calcule_deltat'

  ! Fin
  !-----

END SUBROUTINE calc_deltat
