SUBROUTINE calc_diff (mat,sm)

  USE mes_types
  USE param
  USE functions

  IMPLICIT NONE

  REAL,DIMENSION(:),POINTER :: sm
  TYPE(diag),DIMENSION(:),POINTER :: mat

  INTEGER :: i,j,k,m
  REAL :: d11,d22,d33,d12m,d12p,ci,cio,cj,cjo,Vp,Vm

  DO i=1,9
     mat(i)%tab=0.0
  END DO
  sm=0.0

  !print*,'Entree dans calc_diff'

  mat(1)%dist=0 ! i,j

  mat(2)%dist=1 ! i+1,j

  mat(3)%dist=mx-1 !i-1,j+1

  mat(4)%dist=mx ! i,j+1

  mat(5)%dist=mx+1 !i+1,j+1

  mat(6)%dist=1 ! i-1,j

  mat(7)%dist=mx-1 !i+1,j-1

  mat(8)%dist=mx !i,j-1

  mat(9)%dist=mx+1 ! i-1,j-1
  


  !-------------------------------------------------------------------
  !                          MAILLES CENTRALES                       !
  !-------------------------------------------------------------------


     DO j=2,my-1
        DO i=2,mx-1

           m=mx*(j-1)+i
           ci=1.0-xinterp(i)
           cio=xinterp(i)

           ! right
           d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
           d12p=diff12(i,j,C%diffusion)*deltay(j)/dyp(j)
           d12m=diff12(i,j-1,C%diffusion)*deltay(j)/dyp(j-1)

           ci=1.0-xinterp(i)
           cio=xinterp(i)
           !xinterp(i)=.5*deltax(i)/dxp(i)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d11+ci*(-d12m)
           !i+1,j
           mat(2)%tab(m)=mat(2)%tab(m)-d11+cio*(d12p)
           !i+1,j+1
           mat(5)%tab(m)=mat(5)%tab(m)-cio*d12p
           !i,j+1
           mat(4)%tab(m)=mat(4)%tab(m)
           !i,j-1
           mat(8)%tab(m)=mat(8)%tab(m)+ci*d12m
           !i+1,j-1
           mat(7)%tab(m)=mat(7)%tab(m)
           

           ! Left
           d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
           d12p=diff12(i-1,j,C%diffusion)*deltay(j)/dyp(j)
           d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/dyp(j-1)
           
           ci=xinterp(i-1)
           cio=1.0-xinterp(i-1)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d11-ci*(d12p)
           !i-1,j
           mat(6)%tab(m)=mat(6)%tab(m)-d11-cio*(-d12m)
           !i-1,j+1
           mat(3)%tab(m)=mat(3)%tab(m)
           !i,j+1
           mat(4)%tab(m)=mat(4)%tab(m)+d12p*ci
           !i,j-1
           mat(8)%tab(m)=mat(8)%tab(m)
           !i-1,j-1
           mat(9)%tab(m)=mat(9)%tab(m)-d12m*cio
           

           ! Top
           d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
           d12p=diff12(i,j,C%diffusion)*deltax(i)/dxp(i)
           d12m=diff12(i-1,j,C%diffusion)*deltax(i)/dxp(i-1)

           cj=1.0-yinterp(j)
           cjo=yinterp(j)
           !yinterp(j)=.5*deltay(j)/dyp(j)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d22+cj*(-d12m)
           !i,j+1
           mat(4)%tab(m)=mat(4)%tab(m)-d22+cjo*(d12p)
           !i+1,j
           mat(2)%tab(m)=mat(2)%tab(m)
           !i+1,j+1
           mat(5)%tab(m)=mat(5)%tab(m)-cjo*d12p
           !i-1,j+1
           mat(3)%tab(m)=mat(3)%tab(m)
           !i-1,j
           mat(6)%tab(m)=mat(6)%tab(m)+cj*d12m
           

           ! Bottom
           d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
           d12p=diff12(i,j-1,C%diffusion)*deltax(i)/dxp(i)
           d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/dxp(i-1)
           
           cj=yinterp(j-1)
           cjo=1.0-yinterp(j-1)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d22-cj*(d12p)
           !i,j-1
           mat(8)%tab(m)=mat(8)%tab(m)-d22-cjo*(-d12m)
           !i+1,j
           mat(2)%tab(m)=mat(2)%tab(m)+cj*d12p
           !i+1,j-1
           mat(7)%tab(m)=mat(7)%tab(m)
           !i-1,j-1
           mat(9)%tab(m)=mat(9)%tab(m)-cjo*d12m
           !i-1,j
           mat(6)%tab(m)=mat(6)%tab(m)


        END DO
     END DO




     !-------------------------------------------------------------------
     !                  BOUNDARY CONDITIONS - EDGES                     !
     !-------------------------------------------------------------------

     !-------------------------------------------------------------------
     !                          RIGHT BOUNDARY                          !
     !-------------------------------------------------------------------
     
    
     i=mx
     DO j=2,my-1
        
        m=mx*(j-1)+i

        ! right
        IF (C%right(j)%type/=3) THEN
           d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
           d12p=diff12(i,j,C%diffusion)*deltay(j)/dyp(j)
           d12m=diff12(i,j-1,C%diffusion)*deltay(j)/dyp(j-1)

           !i,j
           IF (C%right(j)%type==1) THEN
              mat(1)%tab(m)=mat(1)%tab(m)+2.0*d11
              sm(m)=sm(m)+2.0*d11*C%right(j)%val&
                   &+.5*(-d12p+d12m)*C%right(j)%val
           ELSEIF (C%right(j)%type==2) THEN
              mat(1)%tab(m)=mat(1)%tab(m)-.5*(-d12p+d12m)
           END IF

           !i+1/2,j+1/2
           IF (C%right(j+1)%type==1) THEN
              sm(m)=sm(m)+.5*d12p*C%right(j+1)%val
           ELSEIF (C%right(j+1)%type==2) THEN 
              mat(4)%tab(m)=mat(4)%tab(m)-.5*d12p
           END IF

           !i+1/2,j-1/2
           IF (C%right(j-1)%type==1) THEN
              sm(m)=sm(m)-.5*d12m*C%right(j-1)%val
           ELSEIF (C%right(j-1)%type==2) THEN 
              mat(8)%tab(m)=mat(8)%tab(m)+.5*d12m
           END IF

           
        END IF



        ! Left
           d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
           d12p=diff12(i-1,j,C%diffusion)*deltay(j)/dyp(j)
           d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/dyp(j-1)
           
           ci=xinterp(i-1)
           cio=1.0-xinterp(i-1)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d11-ci*(d12p)
           !i-1,j
           mat(6)%tab(m)=mat(6)%tab(m)-d11-cio*(-d12m)
           !i-1,j+1
           mat(3)%tab(m)=mat(3)%tab(m)
           !i,j+1
           mat(4)%tab(m)=mat(4)%tab(m)+d12p*ci
           !i,j-1
           mat(8)%tab(m)=mat(8)%tab(m)
           !i-1,j-1
           mat(9)%tab(m)=mat(9)%tab(m)-d12m*cio
        
        
        
        ! Top
        d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
        d12p=diff12(i,j,C%diffusion)*deltax(i)/(deltax(i)/2.0)
        d12m=diff12(i-1,j,C%diffusion)*deltax(i)/dxp(i-1)

        cj=1.0-yinterp(j)
        cjo=yinterp(j)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d22+cj*(-d12m)
        !i,j+1
        mat(4)%tab(m)=mat(4)%tab(m)-d22+cjo*(d12p)
        !i+1/2,j
        IF (C%right(j)%type==1) THEN
           sm(m)=sm(m)+d12p*cj*C%right(j)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)-cj*d12p
        END IF
        !i+1/2,j+1
        IF (C%right(j+1)%type==1) THEN
           sm(m)=sm(m)+d12p*cjo*C%right(j+1)%val
        ELSE
           mat(4)%tab(m)=mat(4)%tab(m)-cjo*d12p
        END IF
        !i-1,j+1
        mat(3)%tab(m)=mat(3)%tab(m)!+cjo*d12m
        !i-1,j
        mat(6)%tab(m)=mat(6)%tab(m)+cj*d12m
        

        ! Bottom
        d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
        d12p=diff12(i,j-1,C%diffusion)*deltax(i)/(deltax(i)/2.0)
        d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/dxp(i-1)
        
        cj=yinterp(j-1)
        cjo=1.0-yinterp(j-1)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d22-cj*(d12p)
        !i,j-1
        mat(8)%tab(m)=mat(8)%tab(m)-d22-cjo*(-d12m)
        !i+1/2,j
        IF (C%right(j)%type==1) THEN
           sm(m)=sm(m)-d12p*cj*C%right(j)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)+cj*d12p
        END IF
        !i+1/2,j-1
        IF (C%right(j-1)%type==1) THEN
           sm(m)=sm(m)-d12p*cjo*C%right(j-1)%val
        ELSE
           mat(8)%tab(m)=mat(8)%tab(m)+cjo*d12p
        END IF
        !i-1,j-1
        mat(9)%tab(m)=mat(9)%tab(m)-cjo*d12m
        !i-1,j
        mat(6)%tab(m)=mat(6)%tab(m)!-cj*d12m


     END DO



  !-------------------------------------------------------------------
  !                          LEFT BOUNDARY                           !
  !-------------------------------------------------------------------


     i=1
     DO j=2,my-1

        m=mx*(j-1)+i

        ! right
           d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
           d12p=diff12(i,j,C%diffusion)*deltay(j)/dyp(j)
           d12m=diff12(i,j-1,C%diffusion)*deltay(j)/dyp(j-1)

           ci=1.0-xinterp(i)
           cio=xinterp(i)
           !xinterp(i)=.5*deltax(i)/dxp(i)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d11+ci*(-d12m)
           !i+1,j
           mat(2)%tab(m)=mat(2)%tab(m)-d11+cio*(d12p)
           !i+1,j+1
           mat(5)%tab(m)=mat(5)%tab(m)-cio*d12p
           !i,j+1
           mat(4)%tab(m)=mat(4)%tab(m)
           !i,j-1
           mat(8)%tab(m)=mat(8)%tab(m)+ci*d12m
           !i+1,j-1
           mat(7)%tab(m)=mat(7)%tab(m)
        

        ! Left
        IF (C%left(j)%type/=3) THEN
           d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
           d12p=diff12(i-1,j,C%diffusion)*deltay(j)/dyp(j)
           d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/dyp(j-1)

           !i,j
           IF (C%left(j)%type==1) THEN
              mat(1)%tab(m)=mat(1)%tab(m)+2.0*d11
              sm(m)=sm(m)+2.0*d11*C%left(j)%val&
                   &+.5*(d12p-d12m)*C%left(j)%val
           ELSEIF (C%left(j)%type==2) THEN
              mat(1)%tab(m)=mat(1)%tab(m)&
                   &-.5*(d12p-d12m)
           END IF

           !i-1/2,j+1/2
           IF (C%left(j+1)%type==1) THEN
              sm(m)=sm(m)-.5*d12p*C%left(j+1)%val
           ELSEIF (C%left(j+1)%type==2) THEN 
              mat(4)%tab(m)=mat(4)%tab(m)+.5*d12p
           END IF

           !i-1/2,j-1/2
           IF (C%left(j-1)%type==1) THEN
              sm(m)=sm(m)+.5*d12m*C%left(j-1)%val
           ELSEIF (C%left(j-1)%type==2) THEN 
              mat(8)%tab(m)=mat(8)%tab(m)-.5*d12m
           END IF

        END IF



        ! Top
        d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
        d12p=diff12(i,j,C%diffusion)*deltax(i)/dxp(i)
        d12m=diff12(i-1,j,C%diffusion)*deltax(i)/(deltax(i)/2.0)
        
        cj=1.0-yinterp(j)
        cjo=yinterp(j)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d22+cj*(-d12m)
        !i,j+1
        mat(4)%tab(m)=mat(4)%tab(m)-d22+cjo*(d12p)
        !i-1,j
        IF (C%left(j)%type==1) THEN
           sm(m)=sm(m)-cj*d12m*C%left(j)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)+cj*d12m
        END IF
        !i-1,j+1
        IF (C%left(j+1)%type==1) THEN
           sm(m)=sm(m)-cjo*d12m*C%left(j+1)%val
        ELSE
           mat(4)%tab(m)=mat(4)%tab(m)+cjo*d12m
        END IF

        !i+1,j
        mat(2)%tab(m)=mat(2)%tab(m)!-cj*d12p
        !i+1,j+1
        mat(5)%tab(m)=mat(5)%tab(m)-cjo*d12p
        


        ! Bottom
        d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
        d12p=diff12(i,j-1,C%diffusion)*deltax(i)/dxp(i)
        d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/(deltax(i)/2.0)
        
        cj=yinterp(j-1)
        cjo=1.0-yinterp(j-1)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d22-cj*(d12p)
        !i,j-1
        mat(8)%tab(m)=mat(8)%tab(m)-d22-cjo*(-d12m)
        !i-1,j
        IF (C%left(j)%type==1) THEN
           sm(m)=sm(m)+cj*d12m*C%left(j)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)-cj*d12m
        END IF
        !i-1,j-1
        IF (C%left(j-1)%type==1) THEN
           sm(m)=sm(m)+cjo*d12m*C%left(j-1)%val
        ELSE
           mat(8)%tab(m)=mat(8)%tab(m)-cjo*d12m
        END IF

        !i+1,j
        mat(2)%tab(m)=mat(2)%tab(m)+cj*d12p
        !i+1,j-1
        mat(7)%tab(m)=mat(7)%tab(m)!+cjo*d12p
        
     END DO
   

  !-------------------------------------------------------------------
  !                          TOP BOUNDARY                           !
  !-------------------------------------------------------------------
  j=my
     DO i=2,mx-1

        m=mx*(j-1)+i

        ! right
        d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
        d12p=diff12(i,j,C%diffusion)*deltay(j)/(deltay(j)/2.0)
        d12m=diff12(i,j-1,C%diffusion)*deltay(j)/dyp(j-1)
        
        ci=1.0-xinterp(i)
        cio=xinterp(i)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d11+ci*(-d12m)
        !i+1,j
        mat(2)%tab(m)=mat(2)%tab(m)-d11+cio*(d12p)
        !i,j+1
        IF (C%top(i)%type==1) THEN
           sm(m)=sm(m)+ci*d12p*C%top(i)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)-ci*d12p
        END IF
        !i+1,j+1
        IF (C%top(i+1)%type==1) THEN
           sm(m)=sm(m)+cio*d12p*C%top(i+1)%val
        ELSE
           mat(2)%tab(m)=mat(2)%tab(m)-cio*d12p
        END IF

        !i,j-1
        mat(8)%tab(m)=mat(8)%tab(m)+ci*d12m
        !i+1,j-1
        mat(7)%tab(m)=mat(7)%tab(m)!+cio*d12m
        

        ! Left
        d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
        d12p=diff12(i-1,j,C%diffusion)*deltay(j)/(deltay(j)/2.0)
        d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/dyp(j-1)
        
        ci=xinterp(i-1)
        cio=1.0-xinterp(i-1)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d11-ci*(d12p)
        !i-1,j
        mat(6)%tab(m)=mat(6)%tab(m)-d11-cio*(-d12m)
        !i,j+1
        IF (C%top(i)%type==1) THEN
           sm(m)=sm(m)-ci*d12p*C%top(i)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)+ci*d12p
        END IF
        !i-1,j+1
        IF (C%top(i-1)%type==1) THEN
           sm(m)=sm(m)-cio*d12p*C%top(i-1)%val
        ELSE
           mat(6)%tab(m)=mat(6)%tab(m)+cio*d12p
        END IF

        !i,j-1
        mat(8)%tab(m)=mat(8)%tab(m)!-ci*d12m
        !i-1,j-1
        mat(9)%tab(m)=mat(9)%tab(m)-cio*d12m
        

        ! Top
        IF (C%top(i)%type/=3) THEN
           d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
           d12p=diff12(i,j,C%diffusion)*deltax(i)/dxp(i)
           d12m=diff12(i-1,j,C%diffusion)*deltax(i)/dxp(i-1)

           !i,j
           IF (C%top(i)%type==1) THEN
              mat(1)%tab(m)=mat(1)%tab(m)+2.0*d22
              sm(m)=sm(m)+2.0*d22*C%top(i)%val&
                   &+.5*(-d12p+d12m)*C%top(i)%val
           ELSEIF (C%top(i)%type==2) THEN
              mat(1)%tab(m)=mat(1)%tab(m)&
                   &+.5*(-d12p+d12m)
           END IF

           !i+1/2,j+1/2
           IF (C%top(i+1)%type==1) THEN
              sm(m)=sm(m)+.5*d12p*C%top(i+1)%val
           ELSEIF (C%top(i+1)%type==2) THEN 
              mat(2)%tab(m)=mat(2)%tab(m)-.5*d12p
           END IF

           !i-1/2,j+1/2
           IF (C%top(i-1)%type==1) THEN
              sm(m)=sm(m)-.5*d12m*C%top(i-1)%val
           ELSEIF (C%top(i-1)%type==2) THEN 
              mat(6)%tab(m)=mat(6)%tab(m)+.5*d12m
           END IF

        END IF


        ! Bottom
           d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
           d12p=diff12(i,j-1,C%diffusion)*deltax(i)/dxp(i)
           d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/dxp(i-1)
           
           cj=yinterp(j-1)
           cjo=1.0-yinterp(j-1)

           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d22-cj*(d12p)
           !i,j-1
           mat(8)%tab(m)=mat(8)%tab(m)-d22-cjo*(-d12m)
           !i+1,j
           mat(2)%tab(m)=mat(2)%tab(m)+cj*d12p
           !i+1,j-1
           mat(7)%tab(m)=mat(7)%tab(m)
           !i-1,j-1
           mat(9)%tab(m)=mat(9)%tab(m)-cjo*d12m
           !i-1,j
           mat(6)%tab(m)=mat(6)%tab(m)
        
     END DO



  !-------------------------------------------------------------------
  !                          BOTTOM BOUNDARY                          !
  !-------------------------------------------------------------------

j=1
DO i=2,mx-1
   
   m=mx*(j-1)+i


        ! right
        d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
        d12p=diff12(i,j,C%diffusion)*deltay(j)/dyp(j)
        d12m=diff12(i,j-1,C%diffusion)*deltay(j)/(deltay(j)/2.0)

        ci=1.0-xinterp(i)
        cio=xinterp(i)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d11+ci*(-d12m)
        !i+1,j
        mat(2)%tab(m)=mat(2)%tab(m)-d11+cio*(d12p)
        !i,j-1
        IF (C%bottom(i)%type==1) THEN
           sm(m)=sm(m)-ci*d12m*C%bottom(i)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)+ci*d12m
        END IF
        !i+1,j-1
        IF (C%bottom(i+1)%type==1) THEN
           sm(m)=sm(m)-cio*d12m*C%bottom(i+1)%val
        ELSE
           mat(2)%tab(m)=mat(2)%tab(m)+cio*d12m
        END IF

        !i+1,j+1
        mat(5)%tab(m)=mat(5)%tab(m)-cio*d12p
        !i,j+1
        mat(4)%tab(m)=mat(4)%tab(m)!-ci*d12p
        

        ! Left
        d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
        d12p=diff12(i-1,j,C%diffusion)*deltay(j)/dyp(j)
        d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/(deltay(j)/2.0)

        ci=xinterp(i-1)
        cio=1.0-xinterp(i-1)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d11-ci*(d12p)
        !i-1,j
        mat(6)%tab(m)=mat(6)%tab(m)-d11-cio*(-d12m)
        !i,j-1
        IF (C%bottom(i)%type==1) THEN
           sm(m)=sm(m)+ci*d12m*C%bottom(i)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)-ci*d12m
        END IF
        !i-1,j-1
        IF (C%bottom(i-1)%type==1) THEN
           sm(m)=sm(m)+cio*d12m*C%bottom(i-1)%val
        ELSE
           mat(6)%tab(m)=mat(6)%tab(m)-cio*d12m
        END IF

        !i-1,j+1
        mat(3)%tab(m)=mat(3)%tab(m)!+cio*d12p
        !i,j+1
        mat(4)%tab(m)=mat(4)%tab(m)+ci*d12p
        

        ! Top
           d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
           d12p=diff12(i,j,C%diffusion)*deltax(i)/dxp(i)
           d12m=diff12(i-1,j,C%diffusion)*deltax(i)/dxp(i-1)

           cj=1.0-yinterp(j)
           cjo=yinterp(j)
           
           !i,j
           mat(1)%tab(m)=mat(1)%tab(m)+d22+cj*(-d12m)
           !i,j+1
           mat(4)%tab(m)=mat(4)%tab(m)-d22+cjo*(d12p)
           !i+1,j
           mat(2)%tab(m)=mat(2)%tab(m)
           !i+1,j+1
           mat(5)%tab(m)=mat(5)%tab(m)-cjo*d12p
           !i-1,j+1
           mat(3)%tab(m)=mat(3)%tab(m)
           !i-1,j
           mat(6)%tab(m)=mat(6)%tab(m)+cj*d12m
        

        ! Bottom
        IF (C%bottom(i)%type/=3) THEN
           d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
           d12p=diff12(i,j-1,C%diffusion)*deltax(i)/dxp(i)
           d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/dxp(i-1)

           !i,j
           IF (C%bottom(i)%type==1) THEN
              mat(1)%tab(m)=mat(1)%tab(m)+2.0*d22
              sm(m)=sm(m)+2.0*d22*C%bottom(i)%val&
                   &+.5*(d12p-d12m)*C%bottom(i)%val
           ELSEIF (C%bottom(i)%type==2) THEN
              mat(1)%tab(m)=mat(1)%tab(m)&
                   &-.5*(d12p-d12m)
           END IF

           !i+1/2,j-1/2
           IF (C%bottom(i+1)%type==1) THEN
              sm(m)=sm(m)-.5*d12p*C%bottom(i+1)%val
           ELSEIF (C%bottom(i+1)%type==2) THEN 
              mat(2)%tab(m)=mat(2)%tab(m)+.5*d12p
           END IF

           !i-1/2,j-1/2
           IF (C%bottom(i-1)%type==1) THEN
              sm(m)=sm(m)+.5*d12m*C%bottom(i-1)%val
           ELSEIF (C%bottom(i-1)%type==2) THEN 
              mat(6)%tab(m)=mat(6)%tab(m)-.5*d12m
           END IF

        END IF

     END DO



     !-------------------------------------------------------------------
     !                  BOUNDARY CONDITIONS - CORNERS                   !
     !-------------------------------------------------------------------


     !-------------------------------------------------------------------
     !                       RIGHT-TOP CORNER                          !
     !-------------------------------------------------------------------

     j=my
     i=mx
  
     m=mx*(j-1)+i

     ! right
     IF (C%right(j)%type/=3) THEN
        d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
        d12p=diff12(i,j,C%diffusion)*deltay(j)/deltay(j)
        d12m=diff12(i,j-1,C%diffusion)*deltay(j)/deltay(j)
        

        !i,j
        IF (C%right(j)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d11
           sm(m)=sm(m)+2.0*d11*C%right(j)%val&
                &+.5*(-d12p+d12m)*C%right(j)%val
        ELSEIF (C%right(j)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)-.5*(-d12p+d12m)
        END IF

        !i+1/2,j+1/2
        IF (C%top(i)%type==1) THEN
           sm(m)=sm(m)+.5*d12p*C%top(i)%val
        ELSEIF (C%top(i)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)-.5*d12p
        END IF

        !i+1/2,j-1/2
        IF (C%right(j-1)%type==1) THEN
           sm(m)=sm(m)-.5*d12m*C%right(j-1)%val
        ELSEIF (C%right(j-1)%type==2) THEN 
           mat(8)%tab(m)=mat(8)%tab(m)+.5*d12m
        END IF
        
     END IF


     ! Left     
     d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
     d12p=diff12(i-1,j,C%diffusion)*deltay(j)/(deltay(j)/2.0)
     d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/dyp(j-1)

     ci=xinterp(i-1)
     cio=1.0-xinterp(i-1)

     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d11-ci*(d12p)
     !i-1,j
     mat(6)%tab(m)=mat(6)%tab(m)-d11-cio*(-d12m)
     !i,j+1
     IF (C%top(i)%type==1) THEN
        sm(m)=sm(m)-ci*d12p*C%top(i)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)+ci*d12p
     END IF
     !i-1,j+1
     IF (C%top(i-1)%type==1) THEN
        sm(m)=sm(m)-cio*d12p*C%top(i-1)%val
     ELSE
        mat(6)%tab(m)=mat(6)%tab(m)+cio*d12p
     END IF

     !i,j-1
     mat(8)%tab(m)=mat(8)%tab(m)!-ci*d12m
     !i-1,j-1
     mat(9)%tab(m)=mat(9)%tab(m)-cio*d12m




     ! Top
     IF (C%top(i)%type/=3) THEN
        d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
        d12p=diff12(i,j,C%diffusion)*deltax(i)/deltax(i)
        d12m=diff12(i-1,j,C%diffusion)*deltax(i)/deltax(i)
        
        !i,j
        IF (C%top(i)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d22
           sm(m)=sm(m)+2.0*d22*C%top(i)%val&
                &+.5*(-d12p+d12m)*C%top(i)%val
        ELSEIF (C%top(i)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &+.5*(-d12p+d12m)
        END IF

        !i+1/2,j+1/2
        IF (C%right(j)%type==1) THEN
           sm(m)=sm(m)+.5*d12p*C%right(j)%val
        ELSEIF (C%right(j)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)-.5*d12p
        END IF

        !i-1/2,j+1/2
        IF (C%top(i-1)%type==1) THEN
           sm(m)=sm(m)-.5*d12m*C%top(i-1)%val
        ELSEIF (C%top(i-1)%type==2) THEN 
           mat(6)%tab(m)=mat(6)%tab(m)+.5*d12m
        END IF

     END IF



     ! Bottom
     d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
        d12p=diff12(i,j-1,C%diffusion)*deltax(i)/(deltax(i)/2.0)
        d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/dxp(i-1)
        
        cj=yinterp(j-1)
        cjo=1.0-yinterp(j-1)

        !i,j
        mat(1)%tab(m)=mat(1)%tab(m)+d22-cj*(d12p)
        !i,j-1
        mat(8)%tab(m)=mat(8)%tab(m)-d22-cjo*(-d12m)
        !i+1/2,j
        IF (C%right(j)%type==1) THEN
           sm(m)=sm(m)-d12p*cj*C%right(j)%val
        ELSE
           mat(1)%tab(m)=mat(1)%tab(m)+cj*d12p
        END IF
        !i+1/2,j-1
        IF (C%right(j-1)%type==1) THEN
           sm(m)=sm(m)-d12p*cjo*C%right(j-1)%val
        ELSE
           mat(8)%tab(m)=mat(8)%tab(m)+cjo*d12p
        END IF
        !i-1,j-1
        mat(9)%tab(m)=mat(9)%tab(m)-cjo*d12m
        !i-1,j
        mat(6)%tab(m)=mat(6)%tab(m)!-cj*d12m
     


     !-------------------------------------------------------------------
     !                        RIGHT-BOTTOM CORNER                        !
     !-------------------------------------------------------------------

     j=1
     i=mx
 
     m=mx*(j-1)+i

     ! right
     IF (C%right(j)%type/=3) THEN
        d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
        d12p=diff12(i,j,C%diffusion)*deltay(j)/deltay(j)
        d12m=diff12(i,j-1,C%diffusion)*deltay(j)/deltay(j)

        !i,j
        IF (C%right(j)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d11
           sm(m)=sm(m)+2.0*d11*C%right(j)%val&
                &+.5*(-d12p+d12m)*C%right(j)%val
        ELSEIF (C%right(j)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &-.5*(-d12p+d12m)
        END IF

        !i+1/2,j+1/2
        IF (C%right(j+1)%type==1) THEN
           sm(m)=sm(m)+.5*d12p*C%right(j+1)%val
        ELSEIF (C%right(j+1)%type==2) THEN 
           mat(4)%tab(m)=mat(4)%tab(m)-.5*d12p
        END IF

        !i+1/2,j-1/2
        IF (C%bottom(i)%type==1) THEN
           sm(m)=sm(m)-.5*d12m*C%bottom(i)%val
        ELSEIF (C%bottom(i)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)+.5*d12m
        END IF

        
     END IF


     ! Left
     d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
     d12p=diff12(i-1,j,C%diffusion)*deltay(j)/dyp(j)
     d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/(deltay(j)/2.0)
     
     ci=xinterp(i-1)
     cio=1.0-xinterp(i-1)
     
     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d11-ci*(d12p)
     !i-1,j
     mat(6)%tab(m)=mat(6)%tab(m)-d11-cio*(-d12m)
     !i,j-1
     IF (C%bottom(i)%type==1) THEN
        sm(m)=sm(m)+ci*d12m*C%bottom(i)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)-ci*d12m
     END IF
     !i-1,j-1
     IF (C%bottom(i-1)%type==1) THEN
        sm(m)=sm(m)+cio*d12m*C%bottom(i-1)%val
     ELSE
        mat(6)%tab(m)=mat(6)%tab(m)-cio*d12m
     END IF
     
     !i-1,j+1
     mat(3)%tab(m)=mat(3)%tab(m)!+cio*d12p
     !i,j+1
     mat(4)%tab(m)=mat(4)%tab(m)+ci*d12p
     

     ! Top
     d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
     d12p=diff12(i,j,C%diffusion)*deltax(i)/(deltax(i)/2.0)
     d12m=diff12(i-1,j,C%diffusion)*deltax(i)/dxp(i-1)

     cj=1.0-yinterp(j)
     cjo=yinterp(j)

     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d22+cj*(-d12m)
     !i,j+1
     mat(4)%tab(m)=mat(4)%tab(m)-d22+cjo*(d12p)
     !i+1/2,j
     IF (C%right(j)%type==1) THEN
        sm(m)=sm(m)+d12p*cj*C%right(j)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)-cj*d12p
     END IF
     !i+1/2,j+1
     IF (C%right(j+1)%type==1) THEN
        sm(m)=sm(m)+d12p*cjo*C%right(j+1)%val
     ELSE
        mat(4)%tab(m)=mat(4)%tab(m)-cjo*d12p
     END IF
     !i-1,j+1
     mat(3)%tab(m)=mat(3)%tab(m)!+cjo*d12m
     !i-1,j
     mat(6)%tab(m)=mat(6)%tab(m)+cj*d12m


     ! Bottom
     IF (C%bottom(i)%type/=3) THEN
        d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
        d12p=diff12(i,j-1,C%diffusion)*deltax(i)/deltax(i)
        d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/deltax(i)
        
        !i,j
        IF (C%bottom(i)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d22
           sm(m)=sm(m)+2.0*d22*C%bottom(i)%val&
                &+.5*(d12p-d12m)*C%bottom(i)%val
        ELSEIF (C%bottom(i)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &-.5*(d12p-d12m)
        END IF

        !i+1/2,j-1/2
        IF (C%right(j)%type==1) THEN
           sm(m)=sm(m)-.5*d12p*C%right(j)%val
        ELSEIF (C%right(j)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)+.5*d12p
        END IF

        !i-1/2,j-1/2
        IF (C%bottom(i-1)%type==1) THEN
           sm(m)=sm(m)+.5*d12m*C%bottom(i-1)%val
        ELSEIF (C%bottom(i-1)%type==2) THEN 
           mat(6)%tab(m)=mat(6)%tab(m)-.5*d12m
        END IF

     END IF




     !-------------------------------------------------------------------
     !                       LEFT-TOP CORNER                           !
     !-------------------------------------------------------------------

     j=my
     i=1
  
     m=mx*(j-1)+i

     ! right
     d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
     d12p=diff12(i,j,C%diffusion)*deltay(j)/(deltay(j)/2.0)
     d12m=diff12(i,j-1,C%diffusion)*deltay(j)/dyp(j-1)

     ci=1.0-xinterp(i)
     cio=xinterp(i)

     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d11+ci*(-d12m)
     !i+1,j
     mat(2)%tab(m)=mat(2)%tab(m)-d11+cio*(d12p)
     !i,j+1
     IF (C%top(i)%type==1) THEN
        sm(m)=sm(m)+ci*d12p*C%top(i)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)-ci*d12p
     END IF
     !i+1,j+1
     IF (C%top(i+1)%type==1) THEN
        sm(m)=sm(m)+cio*d12p*C%top(i+1)%val
     ELSE
        mat(2)%tab(m)=mat(2)%tab(m)-cio*d12p
     END IF

     !i,j-1
     mat(8)%tab(m)=mat(8)%tab(m)+ci*d12m
     !i+1,j-1
     mat(7)%tab(m)=mat(7)%tab(m)!+cio*d12m
     

     ! Left
     IF (C%left(j)%type/=3) THEN
        d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
        d12p=diff12(i-1,j,C%diffusion)*deltay(j)/deltay(j)
        d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/deltay(j)
 
        !i,j
        IF (C%left(j)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d11
           sm(m)=sm(m)+2.0*d11*C%left(j)%val&
                &+.5*(d12p-d12m)*C%left(j)%val
        ELSEIF (C%left(j)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &-.5*(d12p-d12m)
        END IF

        !i-1/2,j+1/2
        IF (C%top(i)%type==1) THEN
           sm(m)=sm(m)-.5*d12p*C%top(i)%val
        ELSEIF (C%top(i)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)+.5*d12p
        END IF

        !i-1/2,j-1/2
        IF (C%left(j-1)%type==1) THEN
           sm(m)=sm(m)+.5*d12m*C%left(j-1)%val
        ELSEIF (C%left(j-1)%type==2) THEN 
           mat(8)%tab(m)=mat(8)%tab(m)-.5*d12m
        END IF
        
     END IF



     ! Top
     IF (C%top(i)%type/=3) THEN
        d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
        d12p=diff12(i,j,C%diffusion)*deltax(i)/deltax(i)
        d12m=diff12(i-1,j,C%diffusion)*deltax(i)/deltax(i)
  
        !i,j
        IF (C%top(i)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d22
           sm(m)=sm(m)+2.0*d22*C%top(i)%val&
                &+.5*(-d12p+d12m)*C%top(i)%val
        ELSEIF (C%top(i)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &+.5*(-d12p+d12m)
        END IF

        !i+1/2,j+1/2
        IF (C%top(i+1)%type==1) THEN
           sm(m)=sm(m)+.5*d12p*C%top(i+1)%val
        ELSEIF (C%top(i+1)%type==2) THEN 
           mat(2)%tab(m)=mat(2)%tab(m)-.5*d12p
        END IF

        !i-1/2,j+1/2
        IF (C%left(j)%type==1) THEN
           sm(m)=sm(m)-.5*d12m*C%left(j)%val
        ELSEIF (C%left(j)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)+.5*d12m
        END IF

     END IF


     ! Bottom
     d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
     d12p=diff12(i,j-1,C%diffusion)*deltax(i)/dxp(i)
     d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/(deltax(i)/2.0)

     cj=yinterp(j-1)
     cjo=1.0-yinterp(j-1)

     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d22-cj*(d12p)
     !i,j-1
     mat(8)%tab(m)=mat(8)%tab(m)-d22-cjo*(-d12m)
     !i-1,j
     IF (C%left(j)%type==1) THEN
        sm(m)=sm(m)+cj*d12m*C%left(j)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)-cj*d12m
     END IF
     !i-1,j-1
     IF (C%left(j-1)%type==1) THEN
        sm(m)=sm(m)+cjo*d12m*C%left(j-1)%val
     ELSE
        mat(8)%tab(m)=mat(8)%tab(m)-cjo*d12m
     END IF

     !i+1,j
     mat(2)%tab(m)=mat(2)%tab(m)+cj*d12p
     !i+1,j-1
     mat(7)%tab(m)=mat(7)%tab(m)!+cjo*d12p




     !-------------------------------------------------------------------
     !                       LEFT-BOTTOM CORNER                          !
     !-------------------------------------------------------------------

     j=1
     i=1

     m=mx*(j-1)+i

     ! right
     d11=diff11(i,j,C%diffusion)*deltay(j)/dxp(i)
     d12p=diff12(i,j,C%diffusion)*deltay(j)/dyp(j)
     d12m=diff12(i,j-1,C%diffusion)*deltay(j)/(deltay(j)/2.0)

     ci=1.0-xinterp(i)
     cio=xinterp(i)

     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d11+ci*(-d12m)
     !i+1,j
     mat(2)%tab(m)=mat(2)%tab(m)-d11+cio*(d12p)
     !i,j-1
     IF (C%bottom(i)%type==1) THEN
        sm(m)=sm(m)-ci*d12m*C%bottom(i)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)+ci*d12m
     END IF
     !i+1,j-1
     IF (C%bottom(i+1)%type==1) THEN
        sm(m)=sm(m)-cio*d12m*C%bottom(i+1)%val
     ELSE
        mat(2)%tab(m)=mat(2)%tab(m)+cio*d12m
     END IF

     !i+1,j+1
     mat(5)%tab(m)=mat(5)%tab(m)-cio*d12p
     !i,j+1
     mat(4)%tab(m)=mat(4)%tab(m)!-ci*d12p
     

     ! Left
     IF (C%left(j)%type/=3) THEN
        d11=diff11(i-1,j,C%diffusion)*deltay(j)/dxp(i-1)
        d12p=diff12(i-1,j,C%diffusion)*deltay(j)/deltay(j)
        d12m=diff12(i-1,j-1,C%diffusion)*deltay(j)/deltay(j)
   
        !i,j
        IF (C%left(j)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d11
           sm(m)=sm(m)+2.0*d11*C%left(j)%val&
                &+.5*(d12p-d12m)*C%left(j)%val
        ELSEIF (C%left(j)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &-.5*(d12p-d12m)
        END IF

        !i-1/2,j+1/2
        IF (C%left(j+1)%type==1) THEN
           sm(m)=sm(m)-.5*d12p*C%left(j+1)%val
        ELSEIF (C%left(j+1)%type==2) THEN 
           mat(4)%tab(m)=mat(4)%tab(m)+.5*d12p
        END IF

        !i-1/2,j-1/2
        IF (C%bottom(i)%type==1) THEN
           sm(m)=sm(m)+.5*d12m*C%bottom(i)%val
        ELSEIF (C%bottom(i)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)-.5*d12m
        END IF

        
     END IF



     ! Top
     d22=diff22(i,j,C%diffusion)*deltax(i)/dyp(j)
     d12p=diff12(i,j,C%diffusion)*deltax(i)/dxp(i)
     d12m=diff12(i-1,j,C%diffusion)*deltax(i)/(deltax(i)/2.0)

     cj=1.0-yinterp(j)
     cjo=yinterp(j)

     !i,j
     mat(1)%tab(m)=mat(1)%tab(m)+d22+cj*(-d12m)
     !i,j+1
     mat(4)%tab(m)=mat(4)%tab(m)-d22+cjo*(d12p)
     !i-1,j
     IF (C%left(j)%type==1) THEN
        sm(m)=sm(m)-cj*d12m*C%left(j)%val
     ELSE
        mat(1)%tab(m)=mat(1)%tab(m)+cj*d12m
     END IF
     !i-1,j+1
     IF (C%left(j+1)%type==1) THEN
        sm(m)=sm(m)-cjo*d12m*C%left(j+1)%val
     ELSE
        mat(4)%tab(m)=mat(4)%tab(m)+cjo*d12m
     END IF

     !i+1,j
     mat(2)%tab(m)=mat(2)%tab(m)!-cj*d12p
     !i+1,j+1
     mat(5)%tab(m)=mat(5)%tab(m)-cjo*d12p
     

     ! Bottom
     IF (C%bottom(i)%type/=3) THEN
        d22=diff22(i,j-1,C%diffusion)*deltax(i)/dyp(j-1)
        d12p=diff12(i,j-1,C%diffusion)*deltax(i)/deltax(i)
        d12m=diff12(i-1,j-1,C%diffusion)*deltax(i)/deltax(i)

        !i,j
        IF (C%bottom(i)%type==1) THEN
           mat(1)%tab(m)=mat(1)%tab(m)+2.0*d22
           sm(m)=sm(m)+2.0*d22*C%bottom(i)%val&
                &+.5*(d12p-d12m)*C%bottom(i)%val
        ELSEIF (C%bottom(i)%type==2) THEN
           mat(1)%tab(m)=mat(1)%tab(m)&
                &-.5*(d12p-d12m)
        END IF

        !i+1/2,j-1/2
        IF (C%bottom(i+1)%type==1) THEN
           sm(m)=sm(m)-.5*d12p*C%bottom(i+1)%val
        ELSEIF (C%bottom(i+1)%type==2) THEN 
           mat(2)%tab(m)=mat(2)%tab(m)+.5*d12p
        END IF

        !i-1/2,j-1/2
        IF (C%left(j)%type==1) THEN
           sm(m)=sm(m)+.5*d12m*C%left(j)%val
        ELSEIF (C%left(j)%type==2) THEN 
           mat(1)%tab(m)=mat(1)%tab(m)-.5*d12m
        END IF
        
     END IF

     ! Drift     
     IF (schema_transport==3) then
        DO j=1,my
           DO i=1,mx-1
              m=mx*(j-1)+i
              Vp=MAX(0.,Vx(i,j))*deltay(j)
              Vm=MIN(0.,Vx(i,j))*deltay(j)
              
              mat(1)%tab(m)=mat(1)%tab(m)+Vp
              mat(6)%tab(m+1)=mat(6)%tab(m+1)-Vp
              mat(2)%tab(m)=mat(2)%tab(m)+Vm
              mat(1)%tab(m+1)=mat(1)%tab(m+1)-Vm
           END DO
        END DO

        DO j=1,my-1
           DO i=1,mx
              m=mx*(j-1)+i
              
              Vp=MAX(0.,Vy(i,j))*deltax(i)
              Vm=MIN(0.,Vy(i,j))*deltax(i)
              
              mat(1)%tab(m)=mat(1)%tab(m)+Vp
              mat(8)%tab(m+mx)=mat(8)%tab(m+mx)-Vp
              mat(4)%tab(m)=mat(4)%tab(m)+Vm
              mat(1)%tab(m+mx)=mat(1)%tab(m+mx)-Vm
           END DO
        END DO
     END IF

END SUBROUTINE calc_diff
