SUBROUTINE calc_vitesse

  !------------------------------------------------------------------------
  ! Role : calcule la vitesse de l'ecoulement
  !------------------------------------------------------------------------

  USE param
  USE mes_types

  implicit none


  ! Declaration des variables locales
  !----------------------------------
  INTEGER :: i,j
  REAL :: pi

  !PRINT*,'Calcul de la vitesse'

  SELECT CASE (type_vit)

     ! Case 1: constante; Case 3: circulaire; Case 4: spirale

  CASE (1)
     Vx=v1  
     Vy=v2

  CASE (2)

     pi=3.1415926536

     ! Vx (right)
     DO j=0,my
        DO i=0,mx               
           Vx(i,j)=-2*pi*(ymesh(j)-.5)
        END DO
     END DO

     ! Vy (top)
     DO j=0,my
        DO i=0,mx
           Vy(i,j)=2*pi*(xmesh(i)-.5)
        END DO
     END DO

  CASE (3)
     
     ! Vx (right)
     DO j=0,my
        DO i=0,mx               
           Vx(i,j)=-xmesh(i)+v1!-.25*xmesh(i)+v1!
        END DO
     END DO

     ! Vy (top)
     DO j=0,my
        DO i=0,mx
           Vy(i,j)=-ymesh(j)+v2!-.25*ymesh(j)+v2!
        END DO
     END DO

     xVx=Vx(:,my)
     yVx=Vy(mx,:)

! Copy-paste case (3) and replace "case (3)" with "case (4)"
! V=xmesh(i)
! W=ymesh(j)
! v1=mu1
! v2=mu2
! Time variable = T
! Vx(i,j)=f(V,W)
! Vy(i,j)=g(V,W), where (f,g)=drift.
! In the file PARAM.DAT, use type_drift = 4

  CASE (4)
     
     ! Vx (right)
     DO j=0,my
        DO i=0,mx               
           Vx(i,j)=-xmesh(i)+0.0!+(1.0/2.0)*(1.0+sign(1.0,5-T))
        END DO
     END DO

     ! Vy (top)
     DO j=0,my
        DO i=0,mx
           Vy(i,j)=-ymesh(j)+0.00;
        END DO
     END DO

     xVx=Vx(:,my)
     yVx=Vy(mx,:)


 CASE (5)
     
     ! Vx (right)
     DO j=0,my
        DO i=0,mx               
           Vx(i,j)=xmesh(i)**2+v1!-.25*xmesh(i)+v1!
        END DO
     END DO

     ! Vy (top)
     DO j=0,my
        DO i=0,mx
           Vy(i,j)=ymesh(j)**2+v2!-.25*ymesh(j)+v2!
        END DO
     END DO

     xVx=Vx(:,my)
     yVx=Vy(mx,:)
  END SELECT


  ! Vitesses sur les mailles fictives
  !-----------------------------------
  !Vx(0)=Vx(1)

  !PRINT*,'Vitesse calculee'
  !PRINT*,' '

END SUBROUTINE calc_vitesse


