SUBROUTINE lec_csub (substrat)

  !---------------------------------------------------------------------
  ! Role : lecture des donnees relatives aux conditions initiales dans
  !  le fichier FCSUB
  !---------------------------------------------------------------------

  USE param
  USE files
  USE functions
  USE alloc

  implicit none

  INTEGER :: i,j,k,l,nbr_ints
  INTEGER :: opt,tester
  CHARACTER(len_buffer) :: buffer
  REAL :: valeur,absc,ord,x_centre,y_centre
  REAL :: rayon,ray,t_cl,val_cl,xmin,xmax,ymin,ymax
  REAL :: bidon,scal,scal_test
  REAL,dimension(:,:),pointer :: substrat

  PRINT*,'Enregistrement des conditions initiales et aux limites'
  PRINT*,'pour le substrat'
  
  open (unit=ucsub,file=FCSUB,status='old')

 
  !print*,'Entree dans lire_ci'
  
  
  ! Conditions initiales
  !----------------------

  substrat=0.0

  buffer=lireligne(ucsub)
  READ(buffer, *, err = 10) opt

  SELECT CASE (opt)
  CASE(1)
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) valeur

     substrat=valeur

  CASE (2)

     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) x_centre,y_centre,rayon
     
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) valeur
     
     DO j=1,my
        DO i=1,mx         
           IF ((xpoints(i)-x_centre)**2+(ypoints(j)-y_centre)**2<=rayon**2) &
                &substrat(i,j)=valeur
        END DO
     END DO


     CASE (3)
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) xmin,xmax,ymin,ymax

     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) valeur
     
     DO j=1,my
        DO i=1,mx          
           IF ((xpoints(i)>=xmin).and.(xpoints(i)<=xmax)&
                &.and.(ypoints(j)>=ymin).and.(ypoints(j)<=ymax))&
                &substrat(i,j)=valeur
        END DO
     END DO

  CASE default
     PRINT*,'Type de condition initiale non encore programme'
     CALL desallocation
     STOP
  END SELECT


  ! Boundary conditions
  !---------------------

  ! Top boundary
  !-------------

  buffer=lireligne(ucsub)
  READ(buffer, *, err = 10) nbr_ints

  DO i=1,nbr_ints
     
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) xmin,xmax,t_cl,val_cl
     
     DO j=1,mx
        absc=xpoints(j)
        IF ((absc>=xmin).and.(absc<xmax)) then
           C%top(j)%type=t_cl
           C%top(j)%val=val_cl
        END IF
     END DO
  END DO
     

  ! Bottom boundary
  !-----------------

  buffer=lireligne(ucsub)
  READ(buffer, *, err = 10) nbr_ints

  DO i=1,nbr_ints
     
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) xmin,xmax,t_cl,val_cl
     
     DO j=1,mx
        absc=xpoints(j)
        IF ((absc>=xmin).and.(absc<xmax)) then
           C%bottom(j)%type=t_cl
           C%bottom(j)%val=val_cl
        END IF
     END DO
  END DO


  ! Left boundary
  !--------------

  buffer=lireligne(ucsub)
  READ(buffer, *, err = 10) nbr_ints

  DO i=1,nbr_ints
     
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) ymin,ymax,t_cl,val_cl
     
     DO j=1,my
        ord=ypoints(j)
        IF ((ord>=ymin).and.(ord<ymax)) then
           C%left(j)%type=t_cl
           C%left(j)%val=val_cl
        END IF
     END DO
  END DO


  ! Right boundary
  !----------------

  buffer=lireligne(ucsub)
  READ(buffer, *, err = 10) nbr_ints

  DO i=1,nbr_ints
     
     buffer=lireligne(ucsub)
     READ(buffer, *, err = 10) ymin,ymax,t_cl,val_cl
     
     DO j=1,my
        ord=ypoints(j)
        IF ((ord>=ymin).and.(ord<ymax)) then
           C%right(j)%type=t_cl
           C%right(j)%val=val_cl
        END IF
     END DO
  END DO

close(ucsub)

print*,'Ok'
print*,' '

  RETURN

10 PRINT*,'Erreur dans les conditions initiales'
  CALL desallocation
  STOP

END SUBROUTINE lec_csub
