SUBROUTINE lec_param

  !-------------------------------------------------------------------------
  ! Role : lecture des parametres relatifs au domaine, aux schemas utilises
  !  et aux substrats
  !-------------------------------------------------------------------------

  USE param
  USE alloc
  USE mes_types
  USE functions
  USE files

  IMPLICIT NONE

  INTEGER :: i,j,k
  CHARACTER(len=len_buffer) :: buffer
  REAL :: vit1,vit2,per_circ

  INTEGER :: nbr_iter_movie
  REAL :: t_movie_min,t_movie_max,dt_movie

  PRINT*,'Lecture des parametres principaux'

  open (unit=uparam,file=FPARAM,status='old')

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xd_min,xd_max,yd_min,yd_max
  lx=xd_max-xd_min
  ly=yd_max-yd_min

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xbreak,ybreak

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) t_0,t_max

  T=t_0
  iter=0
  tester_temps=1

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xp_min,xp_max,yp_min,yp_max

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) nbr_stock

  CALL alloue_real_1D(tps_stock,1,nbr_stock,1)
  
  DO i=1,nbr_stock
     READ(uparam,*) tps_stock(i)
     IF (tps_stock(i)<t_0) THEN
        PRINT*,'Erreur tps_stock < t_0',i
     ELSE IF (tps_stock(i)>t_max) THEN
        PRINT*,'Erreur tps_stock > t_max'
     END IF
  END DO

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) info

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) movie,t_movie_min,t_movie_max,nbr_iter_movie

  FPLOT_MOVIE=TRIM(FPLOTPLT2)//'.visit'
  IF (movie==1) THEN
     DEALLOCATE (tps_stock)
     nbr_stock=nbr_iter_movie+1
     CALL alloue_real_1D(tps_stock,1,nbr_stock,1)
     dt_movie=(t_movie_max-t_movie_min)/nbr_iter_movie
     tps_stock(1)=t_movie_min
     DO i=2,nbr_stock
        tps_stock(i)=t_movie_min+(i-1)*dt_movie
     END DO
  END IF

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) steady_state,test_cv_stat

  k=nbr_stock-1
  if (steady_state==1) k=k+1
  open(unit=10,file='list_cross_1',status='replace')
  write (10,*) k
  close(10)
  open(unit=10,file='list_cross_2',status='replace')
  write (10,*) k
  close(10)

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) go_around

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) schema_transport

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) cfl

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) method_syslin_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) diff_precond

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) test_cv_diff

  !CALL alloue_vitesses

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) type_vit

  !PRINT*,'typ=',type_vit

  SELECT CASE (type_vit)
  CASE (2) 
     buffer=lireligne(uparam)
     READ(buffer, *, err = 10) per_circ
  CASE default
     buffer=lireligne(uparam)
     READ(buffer, *, err = 10) v1,v2
!!$  CASE (3)
!!$     buffer=lireligne(uparam)
!!$     READ(buffer, *, err = 10) per_circ
!!$     CALL calc_vit_circ(per_circ)
!!$     !PRINT*,'per_circ=',per_circ
  END SELECT

  !PRINT*,'Vitesse OK'

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) type_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 20) dloc1,dloc2,dloc3
  
  buffer=lireligne(uparam)
  READ(buffer, *, err = 20) C%tau(1),C%tau(2)

  tau_max=max(C%tau(1),C%tau(2))

  close(uparam)

    ! Prepare cross-correlation
  !---------------------------
  open (unit=uplotplt,file='P1.DAT',status='replace')
  write(uplotplt,'A11',advance='no') 'Vmin,Vmax ='
  write(uplotplt,600) yd_min,yd_max
  write(uplotplt,'A4',advance='no') 'Vr ='
  write(uplotplt,500) ybreak
  write(uplotplt,'A12',advance='no') 't_0, t_max ='
  write(uplotplt,600) t_0,t_max
  write(uplotplt,'A22',advance='no') 'Vplot_min, Vplot_max ='
  write(uplotplt,600) yp_min,yp_max
  write(uplotplt,'A11',advance='no') 'nbr_stock ='
  write(uplotplt,*) 1
  write(uplotplt,500) 0.0
  write(uplotplt,'A6',advance='no') 'info ='
  write(uplotplt,*) 1000000000
  write(uplotplt,'A7',advance='no') 'movie = '
  write(uplotplt,'I1',advance='no') movie
  write(uplotplt,600,advance='no') t_movie_min,t_movie_max
  write(uplotplt,*) nbr_iter_movie
  write(uplotplt,'A14',advance='no') 'steady_state ='
  write(uplotplt,'I1',advance='no') steady_state
  write(uplotplt,500) test_cv_stat
  write(uplotplt,'A11',advance='no') 'go_around ='
  write(uplotplt,*) 1
  write(uplotplt,'A14',advance='no') 'drift_scheme ='
  write(uplotplt,*) schema_transport
  write(uplotplt,'A5',advance='no') 'cfl ='
  write(uplotplt,500) cfl
  write(uplotplt,'A20',advance='no') 'method_syslin_diff ='
  IF ((method_syslin_diff==2).and.(diff_precond==2)) THEN
     write(uplotplt,*) 4
  ELSE
     write(uplotplt,*) method_syslin_diff
  END IF
  write(uplotplt,'A14',advance='no') 'test_cv_diff ='
  write(uplotplt,*) test_cv_diff
  write(uplotplt,'A12',advance='no') 'drift_type ='
  write(uplotplt,*) type_vit
  write(uplotplt,'A4',advance='no') 'mu ='
  write(uplotplt,*) v2
  write(uplotplt,'A11',advance='no') 'diff_type ='
  write(uplotplt,*) type_diff
  write(uplotplt,'A12',advance='no') 'diff_coeff ='
  write(uplotplt,*) dloc2
  write(uplotplt,'A5',advance='no') 'tau ='
  write(uplotplt,*) C%tau(2)
  write(uplotplt,'A19',advance='no') 'initial condition ='
  write(uplotplt,'I1',advance='no') 1
  write(uplotplt,600) 0.1,0.2
  close (uplotplt)
  
  open (unit=uplotplt,file='P2.DAT',status='replace')
  write(uplotplt,'A11',advance='no') 'Vmin,Vmax ='
  write(uplotplt,600) xd_min,xd_max
  write(uplotplt,'A4',advance='no') 'Vr ='
  write(uplotplt,500) xbreak
  write(uplotplt,'A12',advance='no') 't_0, t_max ='
  write(uplotplt,600) t_0,t_max
  write(uplotplt,'A22',advance='no') 'Vplot_min, Vplot_max ='
  write(uplotplt,600) xp_min,xp_max
  write(uplotplt,'A11',advance='no') 'nbr_stock ='
  write(uplotplt,*) 1
  write(uplotplt,500) 0.0
  write(uplotplt,'A6',advance='no') 'info ='
  write(uplotplt,*) 1000000000
  write(uplotplt,'A7',advance='no') 'movie = '
  write(uplotplt,'I1',advance='no') movie
  write(uplotplt,600,advance='no') t_movie_min,t_movie_max
  write(uplotplt,*) nbr_iter_movie
  write(uplotplt,'A14',advance='no') 'steady_state ='
  write(uplotplt,'I1',advance='no') steady_state
  write(uplotplt,500) test_cv_stat
  write(uplotplt,'A11',advance='no') 'go_around ='
  write(uplotplt,*) 1
  write(uplotplt,'A14',advance='no') 'drift_scheme ='
  write(uplotplt,*) schema_transport
  write(uplotplt,'A5',advance='no') 'cfl ='
  write(uplotplt,500) cfl
  write(uplotplt,'A20',advance='no') 'method_syslin_diff ='
  IF ((method_syslin_diff==2).and.(diff_precond==2)) THEN
     write(uplotplt,*) 4
  ELSE
     write(uplotplt,*) method_syslin_diff
  END IF
  write(uplotplt,'A14',advance='no') 'test_cv_diff ='
  write(uplotplt,*) test_cv_diff
  write(uplotplt,'A12',advance='no') 'drift_type ='
  write(uplotplt,*) type_vit
  write(uplotplt,'A4',advance='no') 'mu ='
  write(uplotplt,*) v1
  write(uplotplt,'A11',advance='no') 'diff_type ='
  write(uplotplt,*) type_diff
  write(uplotplt,'A12',advance='no') 'diff_coeff ='
  write(uplotplt,*) dloc1
  write(uplotplt,'A5',advance='no') 'tau ='
  write(uplotplt,*) C%tau(1)
  write(uplotplt,'A19',advance='no') 'initial condition ='
  write(uplotplt,'I1',advance='no') 1
  write(uplotplt,600) 0.1,0.2
  close (uplotplt)

!!$  open (unit=uplotplt,file='P2.DAT',status='replace')
!!$  write(uplotplt,*) 'Vmin,Vmax=',xd_min,xd_max
!!$  write(uplotplt,*) 'Vr=',xbreak
!!$  write(uplotplt,*) 't_0, t_max=',t_0,t_max
!!$  write(uplotplt,*) 'Vplot_min, Vplot_max=',xp_min,xp_max
!!$  write(uplotplt,*) 'nbr_stock=',1
!!$  write(uplotplt,*) 0.0
!!$  write(uplotplt,*) 'info=',1000000000
!!$  write(uplotplt,*) 'movie=',movie,t_movie_min,t_movie_max,nbr_iter_movie
!!$  write(uplotplt,*) 'steady_state=',steady_state,test_cv_stat
!!$  write(uplotplt,*) 'go_around=',1
!!$  write(uplotplt,*) 'drift_scheme=',schema_transport
!!$  write(uplotplt,*) 'cfl=',cfl
!!$  write(uplotplt,*) 'method_syslin_diff=',method_syslin_diff
!!$  write(uplotplt,*) 'test_cv_diff=',test_cv_diff
!!$  write(uplotplt,*) 'drift_type=',type_vit
!!$  write(uplotplt,*) 'mu=',v1
!!$  write(uplotplt,*) 'diff_type=',type_diff
!!$  write(uplotplt,*) 'diff_coeff=',dloc1
!!$  write(uplotplt,*) 'tau=',C%tau(1)
!!$  write(uplotplt,*) 'initial condition=',1,0.1,0.2
!!$  close (uplotplt)

!!$open (unit=uplotplt,file='P1.DAT',status='replace')
!!$  write(uplotplt,*) '=',yd_min,yd_max
!!$  write(uplotplt,*) '=',ybreak
!!$  write(uplotplt,*) '=',t_0,t_max
!!$  write(uplotplt,*) '=',yp_min,yp_max
!!$  write(uplotplt,*) '=',1
!!$  write(uplotplt,*) 0.0
!!$  write(uplotplt,*) '=',1000000000
!!$  write(uplotplt,*) '=',movie,t_movie_min,t_movie_max,nbr_iter_movie
!!$  write(uplotplt,*) '=',steady_state,test_cv_stat
!!$  write(uplotplt,*) '=',1
!!$  write(uplotplt,*) '=',schema_transport
!!$  write(uplotplt,*) '=',cfl
!!$  write(uplotplt,*) '=',method_syslin_diff
!!$  write(uplotplt,*) '=',test_cv_diff
!!$  write(uplotplt,*) '=',type_vit
!!$  write(uplotplt,*) '=',v2
!!$  write(uplotplt,*) '=',type_diff
!!$  write(uplotplt,*) '=',dloc2
!!$  write(uplotplt,*) '=',C%tau(2)
!!$  write(uplotplt,*) '=',1,0.1,0.2
!!$  close (uplotplt)
!!$  
!!$  open (unit=uplotplt,file='P2.DAT',status='replace')
!!$  write(uplotplt,*) '=',xd_min,xd_max
!!$  write(uplotplt,*) '=',xbreak
!!$  write(uplotplt,*) '=',t_0,t_max
!!$  write(uplotplt,*) '=',xp_min,xp_max
!!$  write(uplotplt,*) '=',1
!!$  write(uplotplt,*) 0.0
!!$  write(uplotplt,*) '=',1000000000
!!$  write(uplotplt,*) '=',movie,t_movie_min,t_movie_max,nbr_iter_movie
!!$  write(uplotplt,*) '=',steady_state,test_cv_stat
!!$  write(uplotplt,*) '=',1
!!$  write(uplotplt,*) '=',schema_transport
!!$  write(uplotplt,*) '=',cfl
!!$  write(uplotplt,*) '=',method_syslin_diff
!!$  write(uplotplt,*) '=',test_cv_diff
!!$  write(uplotplt,*) '=',type_vit
!!$  write(uplotplt,*) '=',v1
!!$  write(uplotplt,*) '=',type_diff
!!$  write(uplotplt,*) '=',dloc1
!!$  write(uplotplt,*) '=',C%tau(1)
!!$  write(uplotplt,*) '=',1,0.1,0.2
!!$  close (uplotplt)


  PRINT*,'OK'
  PRINT*,' '

  RETURN

10 PRINT*,"Erreur dans l'entree des parametres"
  close (uparam)
  STOP

20 PRINT*,'Erreur dans les parametres des substrats'
  close (uparam)
  STOP

500 format (f15.8)
600 format (2(f10.5,2X))
 
END SUBROUTINE lec_param







