SUBROUTINE marginal

  USE param
  USE mes_types
  USE functions

  INTEGER :: i,j
  REAL :: s,absc,ord
  
  ! Plot Marginal
  !--------------

  open (unit=30,file='marginal.vtk',status='replace')
  write(30,'(A)') '# vtk DataFile Version 2.0'
  write(30,'(A)') 'Marginal'
  write(30,'(A)') 'ASCII'
  write(30,*) 'DATASET UNSTRUCTURED_GRID'
  write(30,*) 'POINTS',nx,'float'
  
  do i=0,mx
     absc=xmesh(i)
     if (absc>1.5) absc=1.5+.5*absc/lx
     write (30,500,advance='no') -absc,0.0,0.0
  end do
   
  
  close(30)
  
  open (unit=30,file='marginal.vtk',status='old',position='append')
  
  write(30,*) 'CELLS',mx,mx*3
  
  do i=1,mx
     !print*,'ijk=',i,j,k
     write (30,600) 2,i-1,i
  end do

write(30,*) 'CELL_TYPES',mx
DO i=1,mx
   write(30,*) 3
END DO

!WRITE(30,*) 'POINT_DATA',(mx+1)*(my+1)*(mz+1)
WRITE(30,*) 'CELL_DATA',mx

close(30)

open (unit=30,file='marginal.vtk',status='old',position='append')
WRITE(30,*) 'SCALARS ','Marginal',' float 1'
WRITE(30,*) 'LOOKUP_TABLE default'

DO i=1,mx
   s=0.0
   DO j=1,my
      s=s+deltay(j)*C%val(i,j)
   END DO
   WRITE (30,500) s
END DO

  CLOSE (30)


  ! Plot flux
  !-----------
  open (unit=31,file='rflux.vtk',status='replace')
  write(31,'(A)') '# vtk DataFile Version 2.0'
  write(31,'(A)') 'Right flux'
  write(31,'(A)') 'ASCII'
  write(31,*) 'DATASET UNSTRUCTURED_GRID'
  write(31,*) 'POINTS',nx,'float'
  
  do i=0,mx
     absc=xmesh(i)
     if (absc>1.5) absc=1.5+.5*absc/lx
     write (31,500,advance='no') -absc,0.0,0.0
  end do
   
  
  close(31)
  
  open (unit=31,file='rflux.vtk',status='old',position='append')
  
  write(31,*) 'CELLS',mx,mx*3
  
  do i=1,mx
     !print*,'ijk=',i,j,k
     write (31,600) 2,i-1,i
  end do

write(31,*) 'CELL_TYPES',mx
DO i=1,mx
   write(31,*) 3
END DO

!WRITE(31,*) 'POINT_DATA',(mx+1)*(my+1)*(mz+1)
WRITE(31,*) 'CELL_DATA',mx

close(31)

open (unit=31,file='rflux.vtk',status='old',position='append')
WRITE(31,*) 'SCALARS ','Right flux',' float 1'
WRITE(31,*) 'LOOKUP_TABLE default'

j=1
DO i=1,mx
   s=2.0*diff22(i,j,C%diffusion)*C%val(i,j)*deltax(i)/deltay(j)
   WRITE (31,500) s
END DO

  CLOSE (31)



500 format (f30.20)
600 format (9(I6,3X))

END SUBROUTINE marginal
