SUBROUTINE calc_deltat

  !------------------------------------------------------------------------
  ! Role : Calculate time step according to CFL condition on the drift term
  !------------------------------------------------------------------------

  USE functions
  USE param
  USE inter
  USE files

  IMPLICIT NONE

  ! Local variables
  !----------------
  INTEGER :: k,l,i,j
  REAL :: delt,mmax,val

  ! Compute time step
  !------------------
  SELECT CASE (schema_transport)
  CASE (1)
     mmax=0.0
     DO i=1,mx-1
        val=ABS(Vx(i))/MIN(deltax(i),deltax(i+1))
        IF (val>mmax) mmax=val
     END DO
     deltat=cfl/mmax
     deltat_cst=deltat

  CASE (2)
     mmax=0.0
     DO i=1,mx-1
        val=ABS(Vx(i))/MIN(deltax(i),deltax(i+1))
        IF (val>mmax) mmax=val
     END DO
     deltat=1.0/mmax
     mmax=0.0
     DO i=1,mx    
        val=(MAX(0.0,Vx(i-1))-MIN(0.0,Vx(i)))/deltax(i)&
             &-(Vx(i)-Vx(i-1))/deltax(i)
        IF (val>mmax) mmax=val
     END DO
     deltat=MIN(deltat,cfl/mmax)
     deltat_cst=deltat
  END SELECT

  ! Ajust Dt if  T+deltat exceeds the next time at which 
  ! the solution is plotted est superieur au temps de stockage
  !------------------------------------------------------------
  IF (tester_temps<=nbr_stock) THEN
     IF (T+deltat>=tps_stock(tester_temps)) THEN
        deltat=tps_stock(tester_temps)-T
        pri=1
     END IF
  END IF

  IF ((T+deltat>T_max).AND.(steady_state==0)) deltat=T_max-T

500 FORMAT(E19.7)
600 FORMAT(E13.7)

END SUBROUTINE calc_deltat
