SUBROUTINE calc_diff (mat,sm,dt)

  !-----------------------------------------------------------------------
  ! Goal: Assemble the three diagonals of diffusion matrix 
  !       and the right-hand side
  !-----------------------------------------------------------------------

  USE mes_types
  USE param
  USE functions
  USE alloc

  IMPLICIT NONE

  REAL,INTENT(IN) :: dt

  REAL,DIMENSION(:),POINTER :: sm
  TYPE(diag),DIMENSION(:),POINTER :: mat

  INTEGER :: i,j,k,m
  REAL :: dr,dl,dc,ci,cio,d11


  SELECT CASE (type_diff)
  CASE (2) ! time dependent
     DO i=0,mx+1
        C%diffusion(i)=C_diff+.09*abs(cos(2.0*pi*Tplus))
     END DO
  END SELECT

  DO i=1,SIZE(mat)
     mat(i)%tab=0.0
  END DO

  sm=0.0

  !-------------------------------------------------------------------
  !                          INTERIOR  MESHES                        !
  !-------------------------------------------------------------------
  DO i=2,mx-1
     m=i
     dr=diff11(i,C%diffusion)/dxp(i)
     dl=diff11(i-1,C%diffusion)/dxp(i-1)
     mat(1)%tab(m)=mat(1)%tab(m)+dr+dl
     mat(2)%tab(m)=mat(2)%tab(m)-dr
     mat(3)%tab(m)=mat(3)%tab(m)-dl
  END DO


  !------------------------------------------------------------------
  !                           LEFT BOUNDARY                         !
  !------------------------------------------------------------------
  i=1
  m=i  
  dr=diff11(i,C%diffusion)/dxp(i)
  dl=diff11(i-1,C%diffusion)/(dxp(i-1)/2.0)
  mat(1)%tab(m)=mat(1)%tab(m)+dr
  mat(2)%tab(m)=mat(2)%tab(m)-dr

  IF (C%left%type/=3) THEN
     IF (C%left%type==1) THEN
        mat(1)%tab(m)=mat(1)%tab(m)+dl
        sm(m)=sm(m)+dl*0.0
     END IF
  END IF

  !------------------------------------------------------------------
  !                           RIGHT BOUNDARY                        !
  !------------------------------------------------------------------
  i=mx
  m=i
  dr=diff11(i,C%diffusion)/(dxp(i)/2.0)
  dl=diff11(i-1,C%diffusion)/dxp(i-1)
  mat(1)%tab(m)=mat(1)%tab(m)+dl
  mat(3)%tab(m)=mat(3)%tab(m)-dl
  IF (C%right%type/=3) THEN
     IF (C%right%type==1) THEN
        mat(1)%tab(m)=mat(1)%tab(m)+dr
        sm(m)=sm(m)+dr*0.0!C%right%val
     END IF
  END IF

END SUBROUTINE calc_diff
