SUBROUTINE calc_vitesse

  !-------------------------------------------------------------------
  ! Role : Compute the drift coefficient at the interfaces of the mesh
  !        f(V_i+1/2)
  !-------------------------------------------------------------------

  USE param
  USE mes_types

  IMPLICIT NONE


  ! Local variables
  !----------------
  INTEGER :: i

  SELECT CASE (type_vit)

     ! Case 1: constante; Case 3: circulaire; Case 4: spirale

  CASE (1)
     !--------------
     ! Constant drift
     !--------------
     Vx=v1  

  CASE (2)
     !--------------
     ! f(V)=-V-0.3
     !--------------
     DO i=0,mx
        Vx(i)=-xmesh(i)-.3
     END DO

  CASE (3)
     !--------------
     ! f(V)=-V+mu
     !--------------
     DO i=0,mx
        Vx(i)=-xmesh(i)+v1
     END DO

  CASE (4) 
     !--------------------------
     ! f(V)=-(V-0.1)*(V-0.9)+mu
     !--------------------------
     DO i=0,mx
        Vx(i)=(xmesh(i)-0.1)*(xmesh(i)-0.9) + v1
     END DO

  CASE (5) 
     !-----------------------------------------------
     ! Time dependent drift: F(V)=-V+0.5*sin(2*pi*t)
     !-----------------------------------------------
     DO i=0,mx
        Vx(i)=-xmesh(i)+1.0+.5*SIN(2.0*pi*T)
     END DO

  END SELECT

  Vx(0)=Vx(1)

END SUBROUTINE calc_vitesse


