SUBROUTINE lec_param

  !-------------------------------------------------------------------------
  ! Role : Read main data
  !-------------------------------------------------------------------------

  USE param
  USE alloc
  USE mes_types
  USE functions
  USE files

  IMPLICIT NONE

  INTEGER :: i,j
  CHARACTER(len=len_buffer) :: buffer
  REAL :: xmin,xmax,val

  INTEGER :: nbr_iter_movie,type_init
  REAL :: t_movie_min,t_movie_max,dt_movie

  !PRINT*,'Reading parameters'

  OPEN (unit=uparam,file=FPARAM,status='old')

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xd_min,xd_max

  lx=xd_max-xd_min

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) break

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) t_0,t_max

  T=t_0
  iter=0

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) xp_min,xp_max

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) nbr_stock

  CALL alloue_real_1D(tps_stock,1,nbr_stock,1)

  DO i=1,nbr_stock
     READ(uparam,*) tps_stock(i)
     IF (tps_stock(i)<t_0) THEN
        PRINT*,'Error tps_stock < t_0',i
     ELSE IF (tps_stock(i)>t_max) THEN
        PRINT*,'Error tps_stock > t_max'
     END IF
  END DO

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) info

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) movie,t_movie_min,t_movie_max,nbr_iter_movie

  FPLOT_MOVIE=TRIM(FPLOTPLT2)//'.visit'
  IF (movie==1) THEN
     DEALLOCATE (tps_stock)
     nbr_stock=nbr_iter_movie+1
     CALL alloue_real_1D(tps_stock,1,nbr_stock,1)
     dt_movie=(t_movie_max-t_movie_min)/nbr_iter_movie
     tps_stock(1)=t_movie_min
     DO i=2,nbr_stock
        tps_stock(i)=t_movie_min+(i-1)*dt_movie
     END DO
     !open(unit=10,file='sizes',status='old')
     !read (10,*)
     !write (10,*) nbr_stock
     !close(10)
  END IF

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) steady_state,test_cv_stat

  test_steady=steady_state

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) go_around

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) schema_transport

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) cfl

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) method_syslin_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) test_cv_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) type_vit

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) v1

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) type_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) C_diff

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) C%tau

  buffer=lireligne(uparam)
  READ(buffer, *, err = 10) type_init,xmin,xmax

  ! Read mesh data and construct mesh
  !-----------------------------------
  CALL domain

  ! Allocate the main variables
  !----------------------------
  CALL alloue

  ! Fill the pointer containing the diffusion coefficient at each mesh-point
  !-------------------------------------------------------------------------
  C%diffusion=C_diff

  ! Read the diffusion coefficient (if piecewise constant)
  !-------------------------------------------------------
!!$  buffer=lireligne(uparam)
!!$  READ(buffer, *, err = 10) nbr_strates
!!$
!!$  DO j=1,nbr_strates
!!$
!!$     buffer=lireligne(uparam)
!!$     READ(buffer, *, err = 10) xmin,xmax
!!$
!!$     buffer=lireligne(uparam)
!!$     READ(buffer, *, err = 10) diffusion_loc
!!$
!!$     DO i=1,mx
!!$        IF ((xpoints(i)>=xmin).AND.(xpoints(i)<xmax)) &
!!$             &C%diffusion(i)=diffusion_loc
!!$     END DO
!!$  END DO
!!$
!!$  C%diffusion(0)=C%diffusion(1)
!!$  C%diffusion(mx+1)=C%diffusion(mx)


  ! Make initial condition
  !-----------------------
  SELECT CASE (type_init)
  CASE (1)
     ! Uniform distribution
     !----------------------    
     DO i=1,mx          
        IF ((xpoints(i)>=xmin).AND.(xpoints(i)<=xmax)) THEN
           C%val(i)=1.0
           val=val+deltax(i)
        END IF
     END DO
     C%val=C%val/val

  CASE (2) 
     ! Read pointwise from a file
     !----------------------------
     open (unit=ucsub,file=FCSUB,status='old')
     DO i=1,mx
        read (ucsub,*) C%val(i)
     END DO
     close(ucsub)

  END SELECT

  ! Make boundary condition
  !-------------------------
  C%left%type=3
  C%left%val=0.0
  C%right%type=1
  C%right%val=0.0

  CLOSE(uparam)

  !PRINT*,'OK'
  !PRINT*,' '

  RETURN

10 PRINT*,"Error when reading parameters"
  CLOSE (uparam)
  STOP

END SUBROUTINE lec_param







