PROGRAM main

  !--------------------------------------------------------------------------
  ! PROGRAMME PRINCIPAL DE PM3D
  !--------------------------------------------------------------------------

  USE param
  USE mes_types
  USE files 
  USE inter
  USE plot
  USE functions
  USE alloc

  INTEGER :: m,time2d,i,opt
  REAL :: mmax,val
  CHARACTER(len=40),DIMENSION(:),pointer :: list_cross
  CHARACTER(len=40) :: CROSS_CORRELATION

  FIRE='firing_rate'
  OPEN (unit=ufire,file=FIRE,status='replace')
  CLOSE (50)

  READ(5,*) opt
  select case (opt)
  case(1)
     FPARAM='P1.DAT'
     CROSS_CORRELATION='cross_correlation_1'
     open(unit=10,file='list_cross_1',status='old')
  case(2)
     FPARAM='P2.DAT'
     CROSS_CORRELATION='cross_correlation_2'
     open(unit=10,file='list_cross_2',status='old')
  end select

  read(10,*) time2d
  ALLOCATE(list_cross(time2d))
  DO i=1,time2d
     read(10,*) list_cross(i)
  END DO
  close (10)

  ! Read the names of data files
  !------------------------------
  CALL lec_files

  ! Read data from data files
  !--------------------------
  CALL lec_param  

  ! Create result file in the vtk format
  !--------------------------------------
  !CALL create_vtk

  ! Initialize refractory period
  !------------------------------
  CALL init_refractory

  DO i=1,time2d
     print*,"Iteration",i,"of",time2d
     CROSS=list_cross(i)
     ! Begin iterating
     !----------------
     CALL solver
     DO j=1,3
        deallocate(mat_diff(j)%tab)
     END DO
     deallocate(mat_diff)
print*,'End'
print*,' '
  END DO

  open(unit=10,file=FIRE,status='old')
  open(unit=11,file=CROSS_CORRELATION,status='replace')
  DO j=1,time2d
     DO i=1,tester_temps-2
        read(10,*) val
        write(11,500,advance='no') val
     end DO
     read(10,*) val
     write(11,500,advance='yes') val
  end DO
  close(10)
  close(11)
  
  print*,' '
  print*,'End of execution'

  500 FORMAT (f30.20)

END PROGRAM main
