SUBROUTINE solver

  USE param
  USE mes_types
  USE inter
  USE files
  USE plot
  USE alloc

  IMPLICIT NONE

  CHARACTER(len=15) :: chaine
  CHARACTER(len=10) :: nom_champ

  INTEGER :: i,j,k,length
  REAL :: masse,ci,cio
  CHARACTER(len=10) :: fmt

  !PRINT*,'Begin iterations'
  !PRINT*,' '

  !print*,'T_max=',t_max

  ! Allocation and graph of the diffusion matrix
  !----------------------------------------------
  ALLOCATE (mat_diff(3))
  DO i=1,3
     CALL alloue_real_1D (mat_diff(i)%tab,1,mx,1)
     mat_diff(i)%tab=0.0
  END DO
  mat_diff(1)%dist=0 ! i
  mat_diff(2)%dist=1 ! i+1
  mat_diff(3)%dist=1 !i-1
  
  OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='replace')
  CLOSE (uplotplt)

  ! Firing rate
  !WRITE(utool,) tester_temps !tester_temps-1
  !BACKSPACE utool

  T=t_0
  iter=0
  tester_temps=1
  update=0
  mass_out=0.0
  ref%counter=1
  ref%time(ref%counter)=T


  IF (go_around==1) then
     call read_data(CROSS)
  END IF

  IF (steady_state==1) steady_save=C%val

  ! Put the initial condition in a 1D vector (useful in the 2D code)
  !------------------------------------------------------------------
  DO i=1,mx
     sol_1D(i)=C%val(i)
  END DO

  ! Possibly print the initial condition
  !-------------------------------------
  IF (tps_stock(tester_temps)==T) THEN
     OPEN (unit=utool,file=FTOOL,status='replace')
     WRITE(utool,400) tps_stock(tester_temps) !tester_temps-1
     BACKSPACE utool
     READ(utool,*) chaine  
     CLOSE(utool)
     !nom_champ='C_'//TRIM(chaine)
     nom_champ='P'
     OPEN (unit=utool,file=FTOOL,status='replace')
     WRITE(utool,*) len_trim(chaine)+len_trim(FPLOTPLT2)+5
     BACKSPACE utool
     READ(utool,*) fmt
     CLOSE(utool)
     FPLOTPLT=TRIM(FPLOTPLT2)//'_'//TRIM(chaine)//'.vtk'
     fmt='A'//trim(fmt)

     OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='old',position='append')
     WRITE(uplotmovie,fmt) FPLOTPLT
     CLOSE (uplotmovie)

     ! Firing rate
     !------------
     OPEN (unit=ufire,file=FIRE,status='old',position='append')
     WRITE(ufire,500) C%diffusion(mx)*C%val(mx)/(deltax(mx)/2.0)
     CLOSE (ufire)

     SB9=C%val
     !PRINT*,' '
     !PRINT*,'Impression resultat T=',T,'iter=',iter
     CALL create_vtk
     CALL plot_vtk (SB9,nom_champ)
     !PRINT*,'OK'
     !PRINT*,' '
     tester_temps=tester_temps+1
  END IF


  ! MAIN LOOP: iteration of the numerical scheme
  !----------------------------------------------
  DO

     ! Compute the mass
     !-----------------
     masse=mass_out
     DO i=1,mx
        masse=masse+deltax(i)*C%val(i)
     END DO

     ! Possibly print some information on the screen
     !-----------------------------------------------
!!$     IF(MOD(iter,info)==0) THEN
!!$        IF (T<1.0) THEN
!!$           PRINT*,'Information   iter=',iter,'T=',T
!!$           PRINT*,'mass=',masse
!!$        ELSE 
!!$           PRINT*,'Information   iter=',iter,'T=',T
!!$           PRINT*,'mass=',masse
!!$        END IF
!!$     END IF

     pri=0
     lecs=0
     iter=iter+1
     !print*,iter

     ! Calculate the drift term at each meshpoint
     !-------------------------------------------
     CALL calc_vitesse

     ! Compute the time step
     !-----------------------
     CALL calc_deltat
     Tplus=T+deltat

     !---------------------------------------------------------------------
     ! Operator Splitting 2 steps |
     !-----------------------------
     ! Drift step
     !-------------------
     CALL transport(C%val,deltat)
     !---------------
     ! Diffusion step
     !---------------
     CALL calc_diff (mat_diff,sm_diff,deltat)
     CALL diffusion(mat_diff,sm_diff,C%val,source,deltat)
     !----------------------------------------------------------------------

     ! Calculate flux across the threshold and time
     !---------------------------------------------
     IF (C%tau>1d-15) THEN
        DO i=ref%counter,1,-1 
           ref%time(i+1)=ref%time(i)+deltat
           ref%rflux(i+1)=ref%rflux(i)
        END DO
        ref%rflux(1)=C%diffusion(mx)*C%val(mx)/(deltax(mx)/2.0)
        mass_out=mass_out+deltat*ref%rflux(1)
        IF (ref%time(ref%counter)<=C%tau)&
             &ref%counter=ref%counter+1
        !ref%counter=ref%counter+1
     END IF

     ! Update current time
     !--------------------
     T=T+deltat

     ! Possibly print the result
     !-----------------------------------
     IF (pri==1) THEN
        OPEN (unit=utool,file=FTOOL,status='replace')
        WRITE(utool,400) tps_stock(tester_temps) !tester_temps-1
        BACKSPACE utool
        READ(utool,*) chaine  
        CLOSE(utool)
        !nom_champ='C_'//TRIM(chaine)
        nom_champ='P'
        OPEN (unit=utool,file=FTOOL,status='replace')
        WRITE(utool,*) len_trim(chaine)+len_trim(FPLOTPLT2)+5
        BACKSPACE utool
        READ(utool,*) fmt
        CLOSE(utool)
        FPLOTPLT=TRIM(FPLOTPLT2)//'_'//TRIM(chaine)//'.vtk'
        fmt='A'//trim(fmt)

        OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='old',position='append')
        WRITE(uplotmovie,fmt) FPLOTPLT
        CLOSE (uplotmovie)

        ! Firing rate
        !------------
        OPEN (unit=ufire,file=FIRE,status='old',position='append')
        WRITE(ufire,500) C%diffusion(mx)*C%val(mx)/(deltax(mx)/2.0)
        CLOSE (ufire)

        SB9=C%val
        !PRINT*,' '
        !PRINT*,'Impression resultat T=',T,'iter=',iter
        CALL create_vtk
        CALL plot_vtk (SB9,nom_champ)
        !PRINT*,'OK'
        !PRINT*,' '
        tester_temps=tester_temps+1
     END IF

     ! Search for steady state
     !-------------------------
     IF (steady_state==1) THEN
        CALL steady
        IF (test_steady==-1) THEN
           CALL save_data
           test_steady=steady_state
           EXIT
        END IF
     END IF

     ! Exit
     !-----
     IF ((T>=t_max).AND.(steady_state/=1)) THEN
        PRINT*,'Exit T = T_max=',T,'iter=',iter
        CALL save_data
        EXIT
     END IF

     IF (masse<0.0) THEN
        PRINT*,'Execution stopped: mass=',masse,'iter=',iter     
        STOP
     END IF
  END DO

  !PRINT*,'End of iterations'
  !PRINT*,' '

400 FORMAT (f10.4)
500 FORMAT (2(f30.20))

END SUBROUTINE solver
