SUBROUTINE steady

  !--------------------------------------------------------------------------
  ! Role : Test for convergence to a steady state
  !--------------------------------------------------------------------------

  USE mes_types
  USE param
  USE plot

  REAL :: residu

  ! Compute the residual: l-infini norm
  !-------------------------------------

  steady_save(:)=ABS(C%val-steady_save)

  residu=MAXVAL(steady_save)/deltat

  IF(MOD(iter,info)==0) THEN
     PRINT*,'Residual = ',residu
     PRINT*,' ' 
  END IF

  ! Convergence test
  !-------------------
  IF (residu<test_cv_stat) THEN
     test_steady=-1
     FPLOTPLT='Steady_state.vtk'
     OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='old',position='append')
     WRITE(uplotmovie,'A16') FPLOTPLT
     CLOSE (uplotmovie)

     CALL create_vtk
     CALL plot_vtk (C%val,'P')
     !PRINT*,' '
     PRINT*,'Steady state reached    Residual = ',residu
     PRINT*,'Time=',T,'iteration=',iter
     !PRINT*,' '
  END IF

  ! Update table steady_save
  !-------------------------  
  steady_save=C%val


END SUBROUTINE steady
