SUBROUTINE solver

  USE param
  USE mes_types
  USE inter
  USE files
  USE plot
  USE alloc
  USE solver_1d

  implicit none

  CHARACTER(len=15) :: chaine
  CHARACTER(len=10) :: nom_champ,fmt

  INTEGER :: i,j,k,m,ind
  REAL :: masse,val,dt_loc,d_time_dependent,c_time_dependent,pi
  

  !print*,'Entree dans solver'
  PRINT*,'Begin iterations'
  PRINT*,' '

  open (unit=uplotplt,file=FPLOT_MOVIE,status='replace')
  close (uplotplt)

  open (unit=uplotplt,file='times',status='replace')
  close(uplotplt)

  open (unit=uplotplt,file='firing_rate',status='replace')
  close(uplotplt)

  !CALL calc_diff (mat_diff,sm_diff)

  xmat_diff(1)%dist=0 ! i
  xmat_diff(2)%dist=1 ! i+1
  xmat_diff(3)%dist=1 ! i-1

  ymat_diff(1)%dist=0 ! i
  ymat_diff(2)%dist=1 ! i+1
  ymat_diff(3)%dist=1 ! i-1


  T=t_0
  deltat=deltat_cst
  iter=0
  ref%update=0
  ref%counter=1
  ref_times=0.0

  IF (go_around==1) then
     call read_data
  END IF

  ! Put the initial condition into a 1D vector
  !-------------------------------------------- 
  DO j=1,my
     DO i=1,mx
        sol_1D(i+(j-1)*Mx)=C%val(i,j)
     END DO
  END DO

  IF (tps_stock(tester_temps)==T) THEN
     open (unit=utool,file=FTOOL,status='replace')
     WRITE(utool,'(f12.2)') T
     BACKSPACE utool
     READ(utool,*) chaine
     CLOSE(utool)
     nom_champ='P'
     OPEN (unit=utool,file=FTOOL,status='replace')
     WRITE(utool,*) len_trim(chaine)+len_trim(FPLOTPLT2)+5
     BACKSPACE utool
     READ(utool,*) fmt
     CLOSE(utool)
     FPLOTPLT=TRIM(FPLOTPLT2)//'_'//TRIM(chaine)//'.vtk'
     fmt='A'//trim(fmt)

     OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='old',position='append')
     WRITE(uplotmovie,fmt) FPLOTPLT
     CLOSE (uplotmovie)
     print*,' '
     print*,'Printing result T=',T,'iter=',iter
     CALL create_vtk(FPLOTPLT)
     CALL plot_vtk (C%val,nom_champ,FPLOTPLT)
     FPLOTPLT='cross1_'//TRIM(chaine)
     call cross_correlation(FPLOTPLT,1)
     
!!$     ! Plot firing rate
!!$     !-----------------
!!$     open (unit=uplotplt,file='firing_rate',status='old',position='append')
!!$     DO i=1,mx-1
!!$        write(uplotplt,400,advance='no') &
!!$             &C%diffusion(i,my,2)*C%val(i,my)/(deltay(my)/2.0)
!!$     END DO
!!$     i=mx
!!$     write(uplotplt,400,advance='yes') &
!!$          &C%diffusion(i,my,2)*C%val(i,my)/(deltay(my)/2.0)
!!$     close(uplotplt)

     tester_temps=tester_temps+1
  END IF

  DO
     
     ! Mass
     !------
     masse=ref%mass_out
     DO j=1,my
        DO i=1,mx
           masse=masse+deltax(i)*deltay(j)*C%val(i,j)
        END DO
     END DO

     !PRINT*,'Mass =',masse
     IF(MOD(iter,info)==0) THEN
        PRINT*,' '
        IF (T<1.0) THEN
           PRINT*,'Information   iter=',iter,'T=',T
           PRINT*,'Mass =',masse,'deltat=',deltat
        ELSE 
           PRINT*,'Information   iter=',iter,'T=',T
           PRINT*,'Mass =',masse,'deltat=',deltat
        END IF
     END IF

     pri=0
     lecs=0
     iter=iter+1
     deltat=deltat_cst

     ! Compute the drift term
     !-------------------------
     CALL calc_vitesse

     ! Calculation of the time step
     !-----------------------------
     CALL calc_deltat

     !IF(MOD(iter,info)==0) deltat=deltat/2.0

     Tplus=T+deltat
     ! Write your time dependent parameters; use Tplus for time instead of T
     ! Write 
     !d_time_dependent=dloc1
     !c_time_dependent=dloc3/dloc1
     ! to go back to constant parameters
     !-------------------------------------------------
     pi=3.1415926536
     !d_time_dependent=0.1+(0.2/2.0)*(1+sign(1,5.0-Tplus))!sin(Tplus))!0.1*abs(sin(2*pi*T))
     !c_time_dependent=0.05 +(1.0/20.0)*(1+sign(1,Tplus-6))!0.9*abs(sin(Tplus))!Tplus/10
    !c(t)=0.05+(0.1/2.0)(1.0+sign(1,t-5.0)) 
    ! PRINT*,'Time =',Tplus,'c=',c_time_dependent
    d_time_dependent=dloc1
     c_time_dependent=dloc3/dloc1

     C%diffusion(:,:,1)=d_time_dependent
     C%diffusion(:,:,2)=d_time_dependent
     C%diffusion(:,:,3)=d_time_dependent*c_time_dependent

     ! Assemble diffusion matrix
     !---------------------------
     CALL calc_diff (mat_diff,sm_diff)

     weight(1)=max(0.0,deltat-C%tau(1))/deltat
     weight(2)=max(0.0,deltat-C%tau(2))/deltat
     ! Evolve the neurons which are in one refractory state
     !--------------------------------------------------------
     ! Neurons in the 1st refractory state
     !------------------------------------
     active=1
     IF (C%tau(1)>zero) THEN
        mx_1d=my
        ib_1d=jb
        diff_1d(0:my+1)=C%diffusion(mx,0:my+1,1)
        deltax_1d(1:my)=deltay(1:my)
        dxp_1d(0:my)=dyp(0:my)
        xinterp_1d(0:my)=yinterp(0:my)
        weight_1d=weight(2)

        DO i=1,ref%counter(1)
           dt_loc=deltat!min(deltat,C%tau(1)-ref_times(i))
           ysol(:)=ref%rflux(1,i,1:my)
           CALL transport_1d(ysol,yVx,dt_loc)
           CALL calc_diff_1d (ymat_diff,ysm,yVx,dt_loc)
           ! Injection of the neurons that have reached 
           !the 2nd refractory period
           !----------------------------------------------
           IF (C%tau(2)>zero)THEN
              !IF (T+dt_loc>C%tau(2)) THEN
              IF (ref_times(i)+deltat>=C%tau(2)) then
                 ref_fluxes=rboth(i,:)
                 val=p_integral(ref_times,ref_fluxes,&
                      &max(0.0,C%tau(2)),C%tau(2)+dt_loc,ref%counter(2))
                 ysm(jb)=ysm(jb)+val/dt_loc
                 !IF (ref_times(i)+deltat<C%tau(2)) print*,'val=',val,i,ref%counter(1),ref%counter(2),'t=',ref_times(i),ref_times(i-1)
              END IF
              ref_fluxes=tboth(:,i)
              val=p_integral(ref_times,ref_fluxes,&
                   &max(0.0,C%tau(2)-dt_loc),C%tau(2),ref%counter(2))
              ysm(jb)=ysm(jb)+val/dt_loc
              !END IF
           END IF
           CALL diffusion_1d (ymat_diff,ysm,ysol,C%tau(2),dt_loc)
           ref%rflux(1,i,1:my)=ysol(:)         
        END DO
     END IF

     ! Neurons in the 2nd refractory state
     !------------------------------------
     IF (C%tau(2)>zero) THEN
        mx_1d=mx
        ib_1d=ib
        diff_1d(0:mx+1)=C%diffusion(0:mx+1,my,1)
        deltax_1d(1:mx)=deltax(1:mx)
        dxp_1d(0:mx)=dxp(0:mx)
        xinterp_1d(0:mx)=xinterp(0:mx)
        weight_1d=weight(1)

        DO i=1,ref%counter(2)
           dt_loc=deltat!min(deltat,C%tau(2)-ref_times(i))
           xsol(:)=ref%rflux(2,i,1:mx)
           CALL transport_1d(xsol,xVx,dt_loc)
           CALL calc_diff_1d (xmat_diff,xsm,xVx,dt_loc)
           ! Injection of the neurons that have reached 
           !the 1st refractory period
           !----------------------------------------------
           IF (C%tau(1)>zero)THEN
              !IF (T+dt_loc>C%tau(1)) THEN
                 IF (ref_times(i)+deltat>C%tau(1)) then
                    ref_fluxes=tboth(i,:)
                    val=p_integral(ref_times,ref_fluxes,&
                         &max(0.0,C%tau(1)),C%tau(1)+dt_loc,ref%counter(1))!i+1)
                    xsm(ib)=xsm(ib)+val/dt_loc
                 END IF
                 ref_fluxes=rboth(:,i)
                 val=p_integral(ref_times,ref_fluxes,&
                      &max(0.0,C%tau(1)-dt_loc),C%tau(1),ref%counter(1))
                 xsm(ib)=xsm(ib)+val/dt_loc
                 
              !END IF
           END IF
           CALL diffusion_1d (xmat_diff,xsm,xsol,C%tau(1),dt_loc)
           ref%rflux(2,i,1:mx)=xsol(:)
        END DO
     END IF

     ! Operator Splitting
     !-------------------
     active=2
     CALL transport(C%val,deltat)
     CALL diffusion(mat_diff,sm_diff,C%val,source,deltat)

     ! Store ages
     !-----------
     IF (tau_max>zero) THEN
        DO i=max(ref%counter(1),ref%counter(2)),1,-1 
           ref_times(i+1)=ref_times(i)+deltat
        END DO
     END IF

     ! Boundary conditions
     !--------------------
     ! Calculate flux and across the thresholds
     !------------------------------------------
     IF (C%tau(1)>zero) then  
        DO j=1,my
           DO i=ref%counter(1),1,-1
              ref%rflux(1,i+1,j)=ref%rflux(1,i,j)

              ! Flux across the other threshold
              !----------------------------------
              IF (C%tau(2)>zero) then
                 ind=min(i,ref%counter(2))
                 DO k=i,1,-1
                    rboth(i+1,k+1)=rboth(i,k)
                 end DO
                 rboth(i,1)=C%diffusion(mx,my,2)*ref%rflux(1,i,my)&
                      &/(deltay(my)/2.0)
              END IF
           END DO

           ref%rflux(1,1,j)&
                &=C%diffusion(mx,j,1)*C%val(mx,j)/(deltax(mx)/2.0)
           ref%mass_out=ref%mass_out+deltat*ref%rflux(1,1,j)*deltay(j)

        END DO
        k=1
        IF (ref_times(ref%counter(k))<=C%tau(k))&
             &ref%counter(k)=ref%counter(k)+1
     END IF

     !print*,'counter=',ref%counter(1)

     IF (C%tau(2)>zero) then  
        DO j=1,mx
           DO i=ref%counter(2),1,-1
              ref%rflux(2,i+1,j)=ref%rflux(2,i,j)

              ! Flux across the other threshold
              !----------------------------------
              IF (C%tau(1)>zero) then
                 ind=min(i,ref%counter(1))
                 DO k=i,1,-1
                    tboth(i+1,k+1)=tboth(i,k)
                 end DO
                 tboth(i,1)=C%diffusion(mx,my,1)*ref%rflux(2,i,mx)&
                      &/(deltax(mx)/2.0)
              END IF
           END DO
           ref%rflux(2,1,j)&
                &=C%diffusion(j,my,2)*C%val(j,my)/(deltay(my)/2.0)
           ref%mass_out=ref%mass_out+deltat*ref%rflux(2,1,j)*deltax(j)
        END DO
        k=2
        IF (ref_times(ref%counter(k))<=C%tau(k))&
             &ref%counter(k)=ref%counter(k)+1
     END IF

     T=T+deltat

     ! Possibly print the result
     !-----------------------------------
     IF (pri==1) THEN
        open (unit=utool,file=FTOOL,status='replace')
        WRITE(utool,'(f12.2)') T
        BACKSPACE utool
        READ(utool,*) chaine
        CLOSE(utool)
        nom_champ='P'
        OPEN (unit=utool,file=FTOOL,status='replace')
        WRITE(utool,*) len_trim(chaine)+len_trim(FPLOTPLT2)+5
        BACKSPACE utool
        READ(utool,*) fmt
        CLOSE(utool)
        FPLOTPLT=TRIM(FPLOTPLT2)//'_'//TRIM(chaine)//'.vtk'
        fmt='A'//trim(fmt)

        OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='old',position='append')
        WRITE(uplotmovie,fmt) FPLOTPLT
        CLOSE (uplotmovie)
        print*,' '
        print*,'Print result T=',T,'iter=',iter,'deltat=',deltat
        CALL create_vtk(FPLOTPLT)
        CALL plot_vtk (C%val,nom_champ,FPLOTPLT)

        open(unit=10,file='times',status='old',position='append')
        write (10,*) chaine
        close(10)

        FPLOTPLT='cross1_'//TRIM(chaine)
        open(unit=10,file='list_cross_1',status='old',position='append')
        write (10,*) FPLOTPLT
        close(10)
        call cross_correlation(FPLOTPLT,1)

        FPLOTPLT='cross2_'//TRIM(chaine)
        open(unit=10,file='list_cross_2',status='old',position='append')
        write (10,*) FPLOTPLT
        close(10)
        call cross_correlation(FPLOTPLT,2)

!!$        ! Plot firing rate
!!$        !-----------------
!!$        open (unit=uplotplt,file='firing_rate',status='old',position='append')
!!$        DO i=1,mx-1
!!$           write(uplotplt,400,advance='no') &
!!$                &C%diffusion(i,my,2)*C%val(i,my)/(deltay(my)/2.0)
!!$        END DO
!!$        i=mx
!!$        write(uplotplt,400,advance='yes') &
!!$             &C%diffusion(i,my,2)*C%val(i,my)/(deltay(my)/2.0)
!!$        close(uplotplt)
        
        tester_temps=tester_temps+1
     END IF

     ! Search for steady state
     !-------------------------
     IF (steady_state==1) then
        CALL steady
        IF (steady_state==-1) THEN
           CALL save_data
           FPLOTPLT='cross1_steady'
           open(unit=10,file='list_cross_1',status='old',position='append')
           write (10,*) FPLOTPLT
           close(10)
           call cross_correlation(FPLOTPLT,1)
           
           FPLOTPLT='cross2_steady'
           open(unit=10,file='list_cross_2',status='old',position='append')
           write (10,*) FPLOTPLT
           close(10)
           call cross_correlation(FPLOTPLT,2)
           EXIT
        END IF
     END IF

     ! Exit
     !-----
     IF ((T>=t_max).AND.(steady_state/=1)) THEN
        PRINT*,'Exit T = T_max=',T
        CALL save_data
        EXIT
     END IF

  END DO

  PRINT*,'End of iterations'
  PRINT*,' '

400 format (f30.20)
500 FORMAT(E19.7)
600 FORMAT(E13.7)

END SUBROUTINE solver
