SUBROUTINE steady

  !--------------------------------------------------------------------------
  ! Role : Test de convergence d'un etat stationnaire
  !--------------------------------------------------------------------------

  USE mes_types
  USE param
  USE plot

  REAL :: residu
  !REAL,dimension(1:mx) :: sum_current,sum_save
  integer :: istore,jstore,i,j,k


  ! Calcul du residu en norme l-infini
  !------------------------------------
  
!!$  sum_current=0.0
!!$  sum_save=0.0
!!$  DO j=1,my
!!$     DO i=1,mx
!!$        sum_current(i)=sum_current(i)+deltay(j)*C%val(i,j)
!!$        sum_save(i)=sum_save(i)+deltay(j)*steady_save(i,j)
!!$     END DO
!!$  END DO
!!$
!!$  residu=maxval(ABS(sum_current-sum_save))/deltat


  steady_save=ABS(C%val-steady_save)
 
  residu=0.0
  DO j=1,my
     DO i=1,mx
        if (steady_save(i,j)>residu) then
           residu=steady_save(i,j)
           istore=i
           jstore=j
        end if

     END DO
  END DO
  residu=residu/deltat

  IF(MOD(iter,info)==0) THEN
     PRINT*,'Residual = ',residu!,istore,jstore
     !PRINT*,' ' 
  END IF

  ! Convergence test
  !---------------------
  IF (residu<test_cv_stat) THEN
     steady_state=-1
     FPLOTPLT='Steady_state.vtk'
     OPEN (unit=uplotmovie,file=FPLOT_MOVIE,status='old',position='append')
     WRITE(uplotmovie,'A16') FPLOTPLT
     CLOSE (uplotmovie)

     CALL create_vtk(FPLOTPLT)
     CALL plot_vtk (C%val,'P',FPLOTPLT)
     PRINT*,' '
     PRINT*,'Steady state reached    Residual = ',residu
     PRINT*,'Time=',T,'iteration=',iter
     PRINT*,' '
     !call marginal
  END IF

  ! Actualisation du tableau steady_save
  !--------------------------------------
  
  steady_save=C%val
     

END SUBROUTINE steady
