module plot

use files
use mes_types
use param
use functions

implicit none

contains

subroutine create_vtk

integer :: i,j,k,ind1,ind2
real :: absc,ord

print*,"Creation du fichier d'impression"

open (unit=uplotplt,file=FPLOTPLT,status='replace')
write(uplotplt,'(A)') '# vtk DataFile Version 2.0'
write(uplotplt,'(A)') 'Result'
write(uplotplt,'(A)') 'ASCII'
write(uplotplt,*) 'DATASET UNSTRUCTURED_GRID'
write(uplotplt,*) 'POINTS',npx*npy,'float'

DO j=0,mpy
   do i=0,mpx
      write (uplotplt,500,advance='no') xp_mesh(i),yp_mesh(j),0.0
   end do
end DO

close(uplotplt)

open (unit=uplotplt,file=FPLOTPLT,status='old',position='append')

write(uplotplt,*) 'CELLS',mptotal,mptotal*5

DO j=1,mpy
   do i=1,mpx
      ind1=npx*(j-1)+i
      ind2=npx*j+i
      !print*,'ijk=',i,j,k
      write (uplotplt,600) 4,ind1-1,ind1,ind2,ind2-1
   end do
end DO

write(uplotplt,*) 'CELL_TYPES',mptotal
DO i=1,mptotal
   write(uplotplt,*) 9
END DO

!WRITE(uplotplt,*) 'POINT_DATA',(mpx+1)*(mpy+1)*(mpz+1)
WRITE(uplotplt,*) 'CELL_DATA',mptotal

close(uplotplt)

print*,"OK"
print*," "

400 format (2(E14.7,3x))
500 format (3(E14.7,3x))
600 format (9(I6,3X))
700 format (f20.10)

end subroutine create_vtk


subroutine plot_vtk (vec,chaine)

  real,dimension(:,:),pointer :: vec
  !integer,intent(in) :: chaine
  character(len=*),intent(in) :: chaine
  integer :: i,j
  REAL :: absc,ord


  open (unit=uplotplt,file=FPLOTPLT,status='old',position='append')
  WRITE(uplotplt,*) 'SCALARS ',chaine,' float 1'
  WRITE(uplotplt,*) 'LOOKUP_TABLE default'

!Deleted
!!$  DO j=1,my
!!$     DO i=1,mx
!!$        write (uplotplt,500) vec(i,j)
!!$     END DO
!!$  END DO

  !Added
  DO j=1,my
     do i=1,mx
        IF ((xpoints(i)>=xp_min).and.(xpoints(i)<=xp_max)&
             &.and.(xpoints(i)>=xp_min).and.(xpoints(i)<=xp_max))&
             &write(uplotplt,500) vec(i,j)
     end do
  end DO
  !---------------------------------------------------------------
  
close (uplotplt)

  500 format (f30.20)

end subroutine plot_vtk

end module plot
