SUBROUTINE solver

  USE param
  USE mes_types
  USE inter
  USE files
  USE plot
  USE alloc


  implicit none

  CHARACTER(len=15) :: chaine
  CHARACTER(len=10) :: nom_champ

  INTEGER :: i,j,k,m
  REAL :: masse  

  !print*,'Entree dans solver'
  PRINT*,'Begin iterations'
  PRINT*,' '

  IF (movie==1) then
     open (unit=uplotplt,file=FPLOT_MOVIE,status='replace')
     close (uplotplt)
  end IF

  CALL calc_diff (mat_diff,sm_diff)


!!$  print*,'mat1=',mat_diff(1)%tab
!!$print*,'mat2=',mat_diff(2)%tab
!!$print*,'mat3=',mat_diff(3)%tab
!!$print*,'mat4=',mat_diff(4)%tab
!!$print*,'mat5=',mat_diff(5)%tab
!!$print*,'mat6=',mat_diff(6)%tab
!!$print*,'mat7=',mat_diff(7)%tab
!!$print*,'mat8=',mat_diff(8)%tab
!!$print*,'mat9=',mat_diff(9)%tab
!!$stop

  ! Put the initial condition in a 1D vector
  !-------------------------------------------- 
  DO j=1,my
     DO i=1,mx
        sol_1D(i+(j-1)*Mx)=C%val(i,j)
     END DO
  END DO

  T=0.0      

  IF (tps_stock(tester_temps)==T) THEN
     open (unit=utool,file=FTOOL,status='replace')
     WRITE(utool,'(f12.2)') t_0
     BACKSPACE utool
     READ(utool,*) chaine  
     nom_champ='C_'//TRIM(chaine)
     IF (movie==1) THEN
        nom_champ='C'
        FPLOTPLT=TRIM(FPLOT_MOVIE)//TRIM(chaine)//'.vtk'
        open (unit=uplotplt,file=FPLOT_MOVIE,status='old',position='append')
        write(uplotplt,'(A20)') FPLOTPLT
        close (uplotplt)
        !print*,'file=',FPLOTPLT
        !stop
        call create_vtk
     END IF
     SB9=C%val
     print*,' '
     print*,'Impression resultat T=',T,'iter=',iter
     CALL plot_vtk (SB9,nom_champ)
     print*,'OK'
     print*,' '
     tester_temps=tester_temps+1
  END IF

  deltat=deltat_cst
  T=t_0
  iter=0
  ref%update=0
  ref%counter=1
  rtime(ref%counter(1))=T
  ttime(ref%counter(2))=T
  
  DO

     ! Mass
     !------
     masse=ref%mass_out
     DO j=1,my
        DO i=1,mx
           masse=masse+deltax(i)*deltay(j)*C%val(i,j)
        END DO
     END DO

     !PRINT*,'Mass =',masse
     IF(MOD(iter,info)==0) THEN
        IF (T<1.0) THEN
           PRINT*,'Information   iter=',iter,'T=',T
           PRINT*,'Mass =',masse
        ELSE 
           PRINT*,'Information   iter=',iter,'T=',T
           PRINT*,'Mass =',masse
        END IF
     END IF

     pri=0
     lecs=0
     iter=iter+1
     deltat=deltat_cst

     ! Calculation of the time step
     !-----------------------------
     CALL calc_deltat
     Tplus=T+deltat

     ! Splitting de Strang
     !---------------------
!!$     CALL transport(C%val,0.5*deltat)
!!$     CALL calc_diff (mat_diff,sm_diff,deltat)
!!$     CALL diffusion(mat_diff,sm_diff,C%val,source,deltat)
!!$     CALL transport(C%val,0.5*deltat)
!!$


     CALL transport(C%val,deltat)
     CALL diffusion(mat_diff,sm_diff,C%val,source,deltat)

     ! Calculate flux across the threshold and time
     !---------------------------------------------
     IF (C%tau(1)>zero) then    
        DO j=1,my
           rset(ref%counter(1))%val(j)=&
                &=C%diffusion(mx,j)*deltay(j)*C%val(mx,j)/(deltax(mx)/2.0)
           ref%mass_out=ref%mass_out+deltat*rset(ref%counter(1))%val(j)
        END DO
        rtime(ref%counter(1)+1)=Tplus
        ref%counter(1)=ref%counter(1)+1
     END IF
     IF (C%tau(2)>zero) then  
        DO i=1,mx
           tset(ref%counter(2))%val(i)&
                &=C%diffusion(i,my)*deltax(i)*C%val(i,my)/(deltay(my)/2.0)
           ref%mass_out=ref%mass_out+deltat*tset(ref%counter(2))%val(i)
        END DO
        ttime(ref%counter(2)+1)=Tplus
        ref%counter(2)=ref%counter(2)+1
     END IF


     T=T+deltat

     ! Possibly update refractory
     !---------------------------
     IF (C%tau(1)>zero) THEN
        IF (T-rtime(2)>C%tau(1)) then
           ref%update(1)=1
        END IF
     END IF
     IF (C%tau(2)>zero) THEN
        IF (T-ttime(2)>C%tau(2)) then
           ref%update(2)=1
        END IF
     END IF


     IF (ref%update(1)==1) THEN
        ref%counter(1)=ref%counter(1)-1
        DO i=1,ref%counter(1)-1
           rset(i)%val=rset(i+1)%val
           rtime(i)=rtime(i+1)
        END DO
        rtime(ref%counter(1))=rtime(ref%counter(1)+1)
        ref%update(1)=0
     END IF


     DO j=1,2
        IF (ref%update(j)==1) THEN
           ref%counter(j)=ref%counter(j)-1
           DO i=1,ref%counter(j)-1
              ref%rflux(j,i,:)=ref%rflux(j,i+1,:)
              ref%time(j,i)=ref%time(j,i+1)
           END DO
           ref%time(j,ref%counter)=ref%time(j,ref%counter+1)
           ref%update(j)=0
        END IF
     END DO


     ! Possibly print the result
     !-----------------------------------
     IF (pri==1) THEN
        open (unit=utool,file=FTOOL,status='replace')
        WRITE(utool,'(f12.2)') T
        BACKSPACE utool
        READ(utool,*) chaine  
        nom_champ='C_'//TRIM(chaine)
        IF (movie==1) THEN
           nom_champ='C'
           FPLOTPLT=TRIM(FPLOT_MOVIE)//TRIM(chaine)//'.vtk'
           open (unit=uplotplt,file=FPLOT_MOVIE,status='old',position='append')
           write(uplotplt,'(A20)') FPLOTPLT
           close (uplotplt)
           call create_vtk
        END IF
        SB9=C%val
        print*,' '
        print*,'Impression resultat T=',T,'iter=',iter
        CALL plot_vtk (SB9,nom_champ)
        print*,'OK'
        print*,' '
        tester_temps=tester_temps+1
     END IF

     ! Search for steady state
     !-------------------------
     IF (steady_state==1) then
        CALL steady
        IF (steady_state==-1) EXIT
     END IF

     ! Exit
     !-----
     IF ((T>=t_max).AND.(steady_state/=1)) THEN
        PRINT*,'Exit T = T_max=',T
        EXIT
     END IF

  END DO

  PRINT*,'End of iterations'
  PRINT*,' '

500 FORMAT(E19.7)
600 FORMAT(E13.7)

END SUBROUTINE solver
